package com.bqt 
{
    import com.bqt.utils.*;
    import fl.containers.*;
    import flash.display.*;
    import flash.text.*;
    
    public class AutoCreateScreen extends com.bqt.ControlScreen
    {
        public function AutoCreateScreen(arg1:flash.display.DisplayObjectContainer)
        {
            super(arg1);
            this.__setProp_categoryPane_AutoCreateScreen_Layer1_0();
            return;
        }

        protected override function init():void
        {
            super.init();
            this._dataManager = com.bqt.DataManager.getInstance();
            this._scrPane = this.getChildByName("categoryPane") as fl.containers.ScrollPane;
            this._txtCount = this.getChildByName("txtCount") as flash.text.TextField;
            this._txtMarks = this.getChildByName("txtMarks") as flash.text.TextField;
            this._container = new flash.display.Sprite();
            this._scrPane.source = this._container;
            this.tabChildren = false;
            this._container.tabChildren = true;
            this.addEventListener("params_changed", this.onTextInput);
            return;
        }

        internal function addCategories():void
        {
            var loc2:*=null;
            var loc1:*=this._dataManager.getOrderedTypes();
            while (this._container.numChildren) 
            {
                this._container.removeChildAt(0);
            }
            var loc3:*=0;
            while (loc3 < loc1.length) 
            {
                loc2 = new com.bqt.CategoryDetailsRow(this._scrPane.width - 15);
                loc2.index = loc3;
                loc2.description = this._dataManager.getDescFromType(loc1[loc3]);
                loc2.marks = this._dataManager.getMarksByType(loc1[loc3]);
                loc2.qCount = this._dataManager.getQCountByType(loc1[loc3]);
                loc2.type = loc1[loc3];
                loc2.y = this._container.height + 0;
                loc2.editable = true;
                this._container.addChild(loc2);
                ++loc3;
            }
            this._scrPane.update();
            return;
        }

        public function prepare(arg1:Boolean=true):void
        {
            var loc2:*=null;
            this.addCategories();
            this._editable = arg1;
            var loc1:*=0;
            var loc3:*=0;
            this._subQcollection = new Object();
            if (this._dataManager.getTestDetail("createMode") != com.bqt.CreateMode.AUTO) 
            {
                if (this._dataManager.getTestDetail("createMode") == com.bqt.CreateMode.MANUAL) 
                {
                    this._questionIdsPerType = this._dataManager.getSelectedQuestions();
                }
            }
            else 
            {
                this._questionIdsPerType = this._dataManager.getQuestionIdList(this._dataManager.getTestDetail("chapters"), ["*"]);
            }
            loc1 = 0;
            while (loc1 < this._container.numChildren) 
            {
                if (this._container.getChildAt(loc1) is com.bqt.CategoryDetailsRow) 
                {
                    loc3 = 0;
                    loc2 = this._container.getChildAt(loc1) as com.bqt.CategoryDetailsRow;
                    loc2.marks = this._dataManager.getMarksByType(loc2.type);
                    if (!this._subQcollection[loc2.type]) 
                    {
                        this._subQcollection[loc2.type] = new Array();
                    }
                    if (!(this._questionIdsPerType[loc2.type] == undefined) && this._dataManager.getTestDetail("createMode") == com.bqt.CreateMode.AUTO) 
                    {
                        loc3 = this.poluplateSubQList(this._questionIdsPerType[loc2.type]);
                        this._dataManager.setQCountByType(loc2.type, loc3);
                    }
                    loc3 = this._dataManager.getQCountByType(loc2.type);
                    loc2.editable = this._editable;
                    loc2.qCount = this._editable ? 0 : loc3;
                    loc2.description = this._dataManager.getDescFromType(loc2.type) + " [" + loc3.toString() + "]";
                }
                ++loc1;
            }
            this.getTotal();
            this._scrPane.update();
            return;
        }

        internal function poluplateSubQList(arg1:Array):int
        {
            var loc2:*=undefined;
            var loc3:*=null;
            var loc4:*=null;
            var loc5:*=undefined;
            var loc1:*=0;
            var loc6:*=0;
            var loc7:*=arg1;
            for each (loc2 in loc7) 
            {
                if ((loc3 = this._dataManager.getQuestionById(loc2)).subQuestionList.length > 0) 
                {
                    loc5 = 0;
                    while (loc5 < loc3.subQuestionList.length) 
                    {
                        (loc4 = new Object()).qid = loc3.id;
                        loc4.subId = loc5;
                        this._subQcollection[loc3.type].push(loc4);
                        ++loc5;
                    }
                }
                else 
                {
                    (loc4 = new Object()).qid = loc3.id;
                    this._subQcollection[loc3.type].push(loc4);
                }
                loc1 = this._subQcollection[loc3.type].length;
            }
            return loc1;
        }

        internal function onTextInput(arg1:*):void
        {
            this.getTotal();
            return;
        }

        internal function getTotal():void
        {
            var loc3:*=null;
            var loc1:*=0;
            var loc2:*=0;
            var loc4:*=0;
            while (loc4 < this._container.numChildren) 
            {
                if (this._container.getChildAt(loc4) is com.bqt.CategoryDetailsRow) 
                {
                    loc3 = this._container.getChildAt(loc4) as com.bqt.CategoryDetailsRow;
                    loc2 = loc2 + loc3.qCount;
                    loc1 = loc1 + loc3.qCount * loc3.marks;
                }
                ++loc4;
            }
            this._txtCount.text = loc2.toString();
            this._txtMarks.text = loc1.toString();
            return;
        }

        public function prepareTestQuestions():Boolean
        {
            var cdr:com.bqt.CategoryDetailsRow;
            var i:*;
            var matchQ:com.bqt.Question;
            var subQs:Array;
            var col:Object;
            var qID:String;
            var sq:Object;
            var q:com.bqt.Question;
            var oq:com.bqt.Question;
            var n:*;

            var loc1:*;
            cdr = null;
            i = undefined;
            matchQ = null;
            subQs = null;
            col = null;
            qID = null;
            sq = null;
            q = null;
            oq = null;
            n = undefined;
            try 
            {
                if (this._editable) 
                {
                    this._dataManager.clearSelectedQuestions();
                }
                if (!this._questionIdsPerType) 
                {
                    throw new Error("Insufficient Data.");
                }
                i = 0;
                while (i < this._container.numChildren) 
                {
                    if (this._container.getChildAt(i) is com.bqt.CategoryDetailsRow) 
                    {
                        cdr = this._container.getChildAt(i) as com.bqt.CategoryDetailsRow;
                        if (!cdr.validate()) 
                        {
                            throw new Error("Invalid test parameters.");
                        }
                        if (this._dataManager.getQCountByType(cdr.type) && this._dataManager.getQCountByType(cdr.type) < cdr.qCount) 
                        {
                            throw new Error("The selected number of questions cannot be more than the available number of questions.");
                        }
                        this._dataManager.setMarksByType(cdr.type, cdr.marks);
                        this._dataManager.setSelectedQCountByType(cdr.type, cdr.qCount);
                        matchQ = null;
                        if (this._editable) 
                        {
                            subQs = com.bqt.utils.GenericUtils.shuffleArray(this._subQcollection[cdr.type], cdr.qCount);
                            col = new Object();
                            loc2 = 0;
                            var loc3:*=subQs;
                            for each (sq in loc3) 
                            {
                                qID = sq.qid.toString();
                                if (col[qID] == undefined) 
                                {
                                    col[qID] = new Array();
                                }
                                if (sq.subId == undefined) 
                                {
                                    continue;
                                }
                                col[qID].push(sq.subId);
                            }
                            loc2 = 0;
                            loc3 = col;
                            for (qID in loc3) 
                            {
                                q = new com.bqt.Question();
                                oq = this._dataManager.getQuestionById(int(qID));
                                q.questionText = oq.questionText;
                                q.marks = cdr.marks;
                                q.id = oq.id;
                                q.type = oq.type;
                                subQs = col[qID];
                                if (subQs.length > 0) 
                                {
                                    var loc4:*=0;
                                    var loc5:*=subQs;
                                    for each (n in loc5) 
                                    {
                                        q.addSubQuestion(oq.getSubQuestionByIndex(n));
                                        q.addAnsText(oq.getAnswerByIndex(n));
                                    }
                                }
                                else 
                                {
                                    q.answerList = oq.answerList;
                                }
                                this._dataManager.addSelectedQuestion(q);
                            }
                        }
                    }
                    ++i;
                }
                this._dataManager.setTestDetail("qCount", this._txtCount.text);
                this._dataManager.setTestDetail("totalMarks", this._txtMarks.text);
                if (this._dataManager.getSelectedQuestionsCount() < 1) 
                {
                    throw new Error("At least one question is required to create the test.");
                }
                return true;
            }
            catch (er:Error)
            {
                trace(er.getStackTrace());
                com.bqt.MessageBox.show("Error: " + er.message);
            }
            return false;
        }

        function __setProp_categoryPane_AutoCreateScreen_Layer1_0():*
        {
            try 
            {
                this.categoryPane["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.categoryPane.enabled = true;
            this.categoryPane.horizontalLineScrollSize = 4;
            this.categoryPane.horizontalPageScrollSize = 0;
            this.categoryPane.horizontalScrollPolicy = "off";
            this.categoryPane.scrollDrag = false;
            this.categoryPane.source = "";
            this.categoryPane.verticalLineScrollSize = 4;
            this.categoryPane.verticalPageScrollSize = 0;
            this.categoryPane.verticalScrollPolicy = "auto";
            this.categoryPane.visible = true;
            try 
            {
                this.categoryPane["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        public var txtCount:flash.text.TextField;

        public var categoryPane:fl.containers.ScrollPane;

        public var btnNextFromAuto:flash.display.SimpleButton;

        public var btnPrevFrmAuto:flash.display.SimpleButton;

        public var txtMarks:flash.text.TextField;

        internal var _scrPane:fl.containers.ScrollPane;

        internal var _dataManager:com.bqt.DataManager;

        internal var _container:flash.display.Sprite;

        internal var _txtMarks:flash.text.TextField;

        internal var _txtCount:flash.text.TextField;

        internal var _questionIdsPerType:Object;

        internal var _editable:Boolean;

        internal var _subQcollection:Object;
    }
}
