﻿package com.bqt 
{
    import com.bqt.utils.*;
    import fl.data.*;
    import flash.display.*;
    import flash.text.engine.*;
    import flashx.textLayout.conversion.*;
    import flashx.textLayout.elements.*;
    
    public class DataManager extends Object
    {
        public function DataManager()
        {
            this._typesData = new Array();
            super();
            this._questionList = new Array();
            this._chapterToQIdMap = new Object();
            this._quesTypeToDescMap = new Object();
            this._selectedQuestionList = new Object();
            this._autoCreateParams = new Object();
            this._sortOrder = new Array();
            this._graphicCollection = new Object();
            this._testDetail = new Object();
            this._selectedQCount = new Object();
            return;
        }

        public function getSelectedQuestions():Object
        {
            return this._selectedQuestionList;
        }

        public function getSelectedQuestionsCount():int
        {
            var loc2:*=undefined;
            var loc1:*=0;
            var loc3:*=0;
            var loc4:*=this._selectedQuestionList;
            for (loc2 in loc4) 
            {
                loc1 = loc1 + this._selectedQuestionList[loc2].length;
            }
            return loc1;
        }

        public function getTextFlow(arg1:Boolean=false):flashx.textLayout.elements.TextFlow
        {
            var forceNew:Boolean=false;
            var s:String;
            var selectedQuestions:Object;
            var sequence:Array;
            var qType:String;
            var questions:Array;
            var ques:com.bqt.Question;
            var marks:Number;
            var totalQues:int;
            var logoBMP:flash.display.Bitmap;
            var i:*;
            var n:*;
            var subqs:Array;
            var marksString:String;
            var z:*;
            var mq:Object;
            var anslst:Array;

            var loc1:*;
            s = null;
            selectedQuestions = null;
            sequence = null;
            qType = null;
            questions = null;
            ques = null;
            marks = NaN;
            totalQues = 0;
            logoBMP = null;
            i = undefined;
            n = undefined;
            subqs = null;
            marksString = null;
            z = undefined;
            mq = null;
            anslst = null;
            forceNew = arg1;
            if (!(this._textFlow == null) && !forceNew) 
            {
                return this._textFlow;
            }
            var loc2:*=0;
            var loc3:*=this._graphicCollection;
            for (s in loc3) 
            {
                this._graphicCollection[s] = null;
            }
            this._graphicCollection = new Object();
            this._textFlow = null;
            try 
            {
                selectedQuestions = this.getSelectedQuestions();
                this._flowXML = "";
                sequence = this.getOrderedTypes();
                totalQues = 0;
                this._flowXML = this._flowXML + FLOW_OPEN_TAG;
                this._flowXML = this._flowXML + ("<p id=\"test_header\" color=\"#000000\" verticalAlign=\"top\" backgroundcolor=\"#FFFFFF\" fontFamily=\"" + com.bqt.AppConfig.APP_FONT_SANSARIF + "\" kerning=\"" + FONT_KERNING + "\" textDecoration=\"none\" fontLookup=\"" + FONT_LOOKUP + "\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_BIG + "\" fontWeight=\"bold\" textAlign=\"center\">");
                logoBMP = this.getLogoBitmap();
                if (logoBMP) 
                {
                    this._flowXML = this._flowXML + ("<img alt=\"logo\" id=\"logo_img\" width=\"" + com.bqt.AppConfig.LOGO_SIZE + "\" height = \"" + com.bqt.AppConfig.LOGO_SIZE + "\"/><br />");
                }
                this._flowXML = this._flowXML + ("<span id=\"test_name\" textDecoration=\"none\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_BIGGER + "\" fontWeight=\"bold\">");
                this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode(this.getTestDetail("testName"));
                this._flowXML = this._flowXML + SPAN_CLOSE_TAG;
                this._flowXML = this._flowXML + ("<span id=\"test_type\" textDecoration=\"underline\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_MEDIUM + "\" fontWeight=\"normal\">");
                if (this.getTestDetail("testType") != com.bqt.TestType.TEACHER) 
                {
                    this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode("<br />" + "Student\'s Copy" + "<br />");
                }
                else 
                {
                    this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode("<br />" + "Teacher\'s Copy" + "<br />");
                }
                this._flowXML = this._flowXML + SPAN_CLOSE_TAG;
                this._flowXML = this._flowXML + ("<span id=\"tm_dur\" textDecoration=\"none\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_NORMAL + "\" fontWeight=\"normal\">");
                this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode("<br />" + "Total Marks: " + this.getTestDetail("totalMarks") + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + "Time: " + this.getTestDetail("duration") + "<br />");
				this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode("<br />" + "Student's Name: ....................."+ com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10+ "Marks Obtained: ....................." + com.bqt.AppConfig.SAFE_SPACE10 + com.bqt.AppConfig.SAFE_SPACE10 + "<br />");
                this._flowXML = this._flowXML + SPAN_CLOSE_TAG;
                this._flowXML = this._flowXML + PARA_CLOSE_TAG;
                i = 0;
                while (i < sequence.length) 
                {
                    qType = sequence[i];
                    if (!(selectedQuestions[qType] == undefined) && selectedQuestions[qType].length > 0) 
                    {
                        this._flowXML = this._flowXML + (this.getCategoryParaOpenTag("cat_" + qType) + "<span fontWeight=\"bold\" id=\"cat_" + qType + i.toString() + "\" >");
                        questions = selectedQuestions[qType];
                        marks = this.getMarksByType(qType);
                        this._flowXML = this._flowXML + (SPAN_CLOSE_TAG + PARA_CLOSE_TAG);
                        n = 0;
                        while (n < questions.length) 
                        {
                            ++totalQues;
                            ques = questions[n] as com.bqt.Question;
                            subqs = ques.subQuestionList;
                            marksString = subqs.length > 0 ? subqs.length.toString() + " x " + marks.toString() : marks.toString();
                            if (ques.type == "match") 
                            {
                                subqs = ques.getMatchColumns();
                            }
                            this._flowXML = this._flowXML + this.getTextParaOpenTag(ques.type + "_ques_" + totalQues.toString());
                            this._flowXML = this._flowXML + this.getTextSpanOpenTag(ques.type + "_qtext_" + totalQues.toString());
                            if (ques.questionText.indexOf("[img{") > -1) 
                            {
                                mq = new Object();
                                mq.parts = ques.questionText.split("[img{");
                                mq.p1 = mq.parts[0].replace("<br/>", "<br />");
                                mq.p1 = String(mq.p1).substr(0, mq.p1.lastIndexOf("<br />"));
                                mq.parts[0] = mq.p1 + "   ( " + marksString + " )<br />";
                                mq.pn = mq.parts.join("[img{");
                                this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode(totalQues.toString() + ". " + mq.pn + (subqs.length > 0 ? "<br />" : ""));
                            }
                            else 
                            {
                                this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode(totalQues.toString() + ". " + ques.questionText + "   ( " + marksString + " )" + (subqs.length > 0 ? "<br />" : ""));
                            }
                            z = 0;
                            while (z < subqs.length) 
                            {
                                if (ques.type == "match") 
                                {
                                    this._flowXML = this._flowXML + ("<br />" + com.bqt.utils.StringUtils.encode(com.bqt.AppConfig.SAFE_SPACE2 + subqs[z]));
                                }
                                else 
                                {
                                    this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode("<br />" + com.bqt.AppConfig.SAFE_SPACE2 + com.bqt.utils.StringUtils.numberToAlphabet(z) + ") " + subqs[z]);
                                }
                                ++z;
                            }
                            this._flowXML = this._flowXML + SPAN_CLOSE_TAG;
                            this._flowXML = this._flowXML + PARA_CLOSE_TAG;
                            if (this.getTestDetail("testType") == com.bqt.TestType.TEACHER) 
                            {
                                this._flowXML = this._flowXML + this.getTextParaOpenTag(ques.type + "_ans_" + totalQues.toString(), "#333399");
                                this._flowXML = this._flowXML + this.getTextSpanOpenTag(ques.type + "_atext_" + totalQues.toString());
                                this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode("[u{Answers:}u] ");
                                anslst = ques.answerList;
                                if (anslst.length > 0) 
                                {
                                    if (anslst.length != 1) 
                                    {
                                        z = 0;
                                        while (z < anslst.length) 
                                        {
                                            this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode(com.bqt.utils.StringUtils.numberToAlphabet(z) + ") " + String(anslst[z]) + com.bqt.AppConfig.SPACE8);
                                            ++z;
                                        }
                                    }
                                    else 
                                    {
                                        this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode(String(anslst[0]));
                                    }
                                }
                                else 
                                {
                                    this._flowXML = this._flowXML + com.bqt.utils.StringUtils.encode(com.bqt.AppConfig.NO_ANS_STRING);
                                }
                                this._flowXML = this._flowXML + SPAN_CLOSE_TAG;
                                this._flowXML = this._flowXML + PARA_CLOSE_TAG;
                            }
                            this.testForXML(com.bqt.utils.StringUtils.deSanitizeString(this._flowXML + FLOW_CLOSE_TAG));
                            ++n;
                        }
                    }
                    ++i;
                }
                this._flowXML = this._flowXML + FLOW_CLOSE_TAG;
                this._flowXML = com.bqt.utils.StringUtils.deSanitizeString(this._flowXML);
                this._textFlow = new flashx.textLayout.elements.TextFlow();
                this._textFlow = flashx.textLayout.conversion.TextConverter.importToFlow(new XML(this._flowXML), flashx.textLayout.conversion.TextConverter.TEXT_LAYOUT_FORMAT);
            }
            catch (er:Error)
            {
                trace(er.getStackTrace());
                _textFlow = null;
            }
            return this._textFlow;
        }

        public function addToGraphicCollection(arg1:String, arg2:flash.display.DisplayObject):void
        {
            this._graphicCollection[arg1] = arg2;
            return;
        }

        public function getGraphicFromCollection(arg1:String):flash.display.DisplayObject
        {
            if (this._graphicCollection[arg1] != undefined) 
            {
                return this._graphicCollection[arg1];
            }
            return null;
        }

        public function clearGraphicCollection():void
        {
            var loc1:*=null;
            var loc2:*=0;
            var loc3:*=this._graphicCollection;
            for (loc1 in loc3) 
            {
                delete this._graphicCollection[loc1];
            }
            this._graphicCollection = new Object();
            return;
        }

        public function reInit():void
        {
            while (this._questionList.length) 
            {
                this._questionList.shift();
            }
            this._questionList = new Array();
            while (this._sortOrder.length) 
            {
                this._sortOrder.shift();
            }
            this._sortOrder = new Array();
            this._chapterToQIdMap = new Object();
            this._quesTypeToDescMap = new Object();
            this._selectedQuestionList = new Object();
            this._autoCreateParams = new Object();
            this._graphicCollection = new Object();
            this._testDetail = new Object();
            this._selectedQCount = new Object();
            return;
        }

        public function reset():void
        {
            var loc1:*=null;
            var loc2:*=0;
            var loc3:*=this._testDetail;
            for (loc1 in loc3) 
            {
                delete this._testDetail[loc1];
            }
            this._testDetail = null;
            this._testDetail = new Object();
            this.clearSelectedQuestions();
            loc2 = 0;
            loc3 = this._autoCreateParams;
            for (loc1 in loc3) 
            {
                this._autoCreateParams[loc1].marks = com.bqt.AppConfig.DEFAULT_MARKS_PER_CATEGORY;
                this._autoCreateParams[loc1].count = 0;
                this.setSelectedQCountByType(loc1, 0);
            }
            this._textFlow = null;
            this._logoBD = null;
            this.clearGraphicCollection();
            return;
        }

        public function clearSelectedQuestions():void
        {
            var loc1:*=null;
            var loc2:*=0;
            var loc3:*=this._selectedQuestionList;
            for (loc1 in loc3) 
            {
                delete this._selectedQuestionList[loc1];
            }
            this._selectedQuestionList = null;
            this._selectedQuestionList = new Object();
            return;
        }

        internal function testForXML(arg1:String):void
        {
            var ele:String;

            var loc1:*;
            ele = arg1;
            try 
            {
                new XML("<elem>" + ele + "</elem>");
            }
            catch (er:*)
            {
                trace(ele);
            }
            return;
        }

        internal function getCategoryParaOpenTag(arg1:String=""):String
        {
            return "<p color=\"#000000\" id=\"" + arg1 + "\" backgroundcolor=\"#FFFFFF\" fontFamily=\"" + com.bqt.AppConfig.APP_FONT_SANSARIF + "\" kerning=\"" + FONT_KERNING + "\" textDecoration=\"none\" fontLookup=\"" + FONT_LOOKUP + "\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_MEDIUM + "\" fontWeight=\"bold\" textAlign=\"left\">";
        }

        internal function getTextParaOpenTag(arg1:String="", arg2:String="#000000"):String
        {
            return "<p color=\"" + arg2 + "\" id=\"" + arg1 + "\" backgroundcolor=\"#FFFFFF\" fontFamily=\"" + com.bqt.AppConfig.APP_FONT_SANSARIF + "\" kerning=\"" + FONT_KERNING + "\" textDecoration=\"none\" fontLookup=\"" + FONT_LOOKUP + "\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_NORMAL + "\" fontWeight=\"normal\" textAlign=\"left\">";
        }

        internal function getTextSpanOpenTag(arg1:String=""):String
        {
            return "<span color=\"#000000\" id=\"" + arg1 + "\" backgroundcolor=\"#FFFFFF\" fontFamily=\"" + com.bqt.AppConfig.APP_FONT_SANSARIF + "\" kerning=\"" + FONT_KERNING + "\" textDecoration=\"none\" fontLookup=\"" + FONT_LOOKUP + "\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_NORMAL + "\" fontWeight=\"normal\" textAlign=\"left\">";
        }

        public static function getInstance():com.bqt.DataManager
        {
            if (_instance == null) 
            {
                _instance = new DataManager();
            }
            return _instance;
        }

        internal function clearObject(arg1:Object):void
        {
            var loc1:*=null;
            var loc2:*=null;
            if (arg1 != null) 
            {
                var loc3:*=0;
                var loc4:*=arg1;
                for (loc1 in loc4) 
                {
                    if (arg1[loc1] is Array) 
                    {
                        loc2 = arg1[loc1] as Array;
                        while (loc2.length) 
                        {
                            loc2.shift();
                        }
                    }
                    delete arg1[loc1];
                }
            }
            arg1 = new Object();
            return;
        }

        public function createTypeToDescMap(arg1:XMLList):void
        {
            var loc1:*=0;
            while (loc1 < arg1.length()) 
            {
                this._quesTypeToDescMap[arg1[loc1].@lbl] = arg1[loc1].@desc;
                this._selectedQuestionList[arg1[loc1].@lbl] = new Array();
                this._autoCreateParams[arg1[loc1].@lbl] = new Object();
                this._autoCreateParams[arg1[loc1].@lbl].marks = com.bqt.AppConfig.DEFAULT_MARKS_PER_CATEGORY;
                this._autoCreateParams[arg1[loc1].@lbl].count = 0;
                this._sortOrder.push(arg1[loc1].@lbl);
                ++loc1;
            }
            return;
        }

        public function getQuestionTypeDataProvider():fl.data.DataProvider
        {
            var loc1:*=new fl.data.DataProvider();
            var loc2:*=0;
            while (loc2 < this._sortOrder.length) 
            {
                loc1.addItem({"label":this._quesTypeToDescMap[this._sortOrder[loc2]], "data":this._sortOrder[loc2]});
                ++loc2;
            }
            return loc1;
        }

        public function getLogoBitmap():flash.display.Bitmap
        {
            if (this._logoBD != null) 
            {
                return new flash.display.Bitmap(this._logoBD, "auto", true);
            }
            return null;
        }

        public function setLogoSource(arg1:flash.display.DisplayObject):void
        {
            var source:flash.display.DisplayObject;

            var loc1:*;
            source = arg1;
            try 
            {
                this._logoBD = new flash.display.BitmapData(com.bqt.AppConfig.LOGO_SIZE, com.bqt.AppConfig.LOGO_SIZE, false, 16777215);
                this._logoBD.draw(source);
            }
            catch (er:Error)
            {
                _logoBD = null;
            }
            return;
        }

        public function setTestDetail(arg1:String, arg2:*):*
        {
            this._testDetail[arg1] = arg2;
            return;
        }

        public function getTestDetail(arg1:String):*
        {
            if (!this._testDetail[arg1]) 
            {
                return null;
            }
            if (this._testDetail[arg1] is String && this._testDetail[arg1].toString().split(" ").join("").length == 0) 
            {
                return null;
            }
            return this._testDetail[arg1];
        }

        public function getOrderedTypes():Array
        {
            return new Array().concat(this._sortOrder);
        }

        public function getDescFromType(arg1:String):String
        {
            if (this._quesTypeToDescMap[arg1]) 
            {
                return this._quesTypeToDescMap[arg1];
            }
            return "Miscellaneous";
        }

        public function getMarksByType(arg1:String):Number
        {
            return Number(this._autoCreateParams[arg1].marks);
        }

        public function setMarksByType(arg1:String, arg2:Number):void
        {
            if (this._autoCreateParams[arg1]) 
            {
                this._autoCreateParams[arg1].marks = arg2;
            }
            return;
        }

        public function getQCountByType(arg1:String):Number
        {
            try 
            {
                return Number(this._autoCreateParams[arg1].count);
            }
            catch (er:*)
            {
            };
            return 0;
        }

        public function setSelectedQCountByType(arg1:String, arg2:Number):void
        {
            this._selectedQCount[arg1] = arg2;
            return;
        }

        public function getSelectedQCountByType(arg1:String):Number
        {
            try 
            {
                return Number(this._selectedQCount[arg1]);
            }
            catch (er:*)
            {
            };
            return 0;
        }

        public function setQCountByType(arg1:String, arg2:Number):void
        {
            if (this._autoCreateParams[arg1]) 
            {
                this._autoCreateParams[arg1].count = arg2;
            }
            return;
        }

        public function addQuestion(arg1:com.bqt.Question):void
        {
            var loc2:*=null;
            this._questionList[arg1.id] = arg1;
            var loc1:*="ch" + arg1.chapterNo.toString();
            if (this._chapterToQIdMap[loc1] == undefined) 
            {
                this._chapterToQIdMap[loc1] = new Object();
            }
            if (this._chapterToQIdMap[loc1][arg1.type] == undefined) 
            {
                this._chapterToQIdMap[loc1][arg1.type] = new Array();
            }
            loc2 = this._chapterToQIdMap[loc1][arg1.type] as Array;
            if (loc2.indexOf(arg1.id) == -1) 
            {
                loc2.push(arg1.id);
            }
            return;
        }

        public function getQuestionById(arg1:int):com.bqt.Question
        {
            return this._questionList[arg1] as com.bqt.Question;
        }

        public function getQuestionIdList(arg1:Array, arg2:Array):Object
        {
            var loc2:*=null;
            var loc3:*=undefined;
            var loc4:*=undefined;
            var loc5:*=null;
            var loc6:*=null;
            var loc1:*=new Object();
            if (arg2 && !(arg2[0] == "*")) 
            {
                while (arg2.length) 
                {
                    loc2 = arg2.shift();
                    loc1[loc2] = new Array();
                    var loc7:*=0;
                    var loc8:*=arg1;
                    for each (loc3 in loc8) 
                    {
                        if (!(!(this._chapterToQIdMap["ch" + loc3.toString()] == undefined) && !(this._chapterToQIdMap["ch" + loc3][loc2] == undefined))) 
                        {
                            continue;
                        }
                        loc1[loc2] = loc1[loc2].concat(this._chapterToQIdMap["ch" + loc3.toString()][loc2].slice());
                    }
                }
            }
            else if (arg2[0] != "*") 
            {
                loc1["all"] = new Array();
                loc7 = 0;
                loc8 = arg1;
                for each (loc3 in loc8) 
                {
                    if (this._chapterToQIdMap["ch" + loc3.toString()] == undefined) 
                    {
                        continue;
                    }
                    loc9 = 0;
                    loc10 = this._chapterToQIdMap["ch" + loc3.toString()];
                    for (loc6 in loc10) 
                    {
                        loc1["all"] = loc1["all"].concat(this._chapterToQIdMap["ch" + loc3.toString()][loc6].slice());
                    }
                }
            }
            else 
            {
                loc7 = 0;
                loc8 = arg1;
                for each (loc3 in loc8) 
                {
                    loc4 = "ch" + loc3.toString();
                    if (this._chapterToQIdMap[loc4] == undefined) 
                    {
                        continue;
                    }
                    var loc9:*=0;
                    var loc10:*=this._chapterToQIdMap[loc4];
                    for (loc2 in loc10) 
                    {
                        if (!loc1[loc2]) 
                        {
                            loc1[loc2] = new Array();
                        }
                        loc5 = this._chapterToQIdMap[loc4][loc2].slice();
                        loc1[loc2] = loc1[loc2].concat(loc5);
                    }
                }
            }
            return loc1;
        }

        public function hasSelectedQuestion(arg1:*):Boolean
        {
            var loc2:*=null;
            var loc3:*=null;
            var loc4:*=undefined;
            var loc5:*=null;
            var loc1:*=-1;
            if (arg1 is com.bqt.Question) 
            {
                loc1 = arg1.id;
            }
            else if (arg1 is String) 
            {
                loc1 = int(arg1);
            }
            else 
            {
                loc1 = arg1;
            }
            var loc6:*=0;
            var loc7:*=this._selectedQuestionList;
            for (loc2 in loc7) 
            {
                loc3 = this._selectedQuestionList[loc2] as Array;
                loc4 = 0;
                while (loc4 < loc3.lengthl) 
                {
                    if ((loc5 = loc3[loc4]).id == loc1) 
                    {
                        return true;
                    }
                    ++loc4;
                }
            }
            return false;
        }

        public function addSelectedQuestion(arg1:com.bqt.Question):void
        {
            if (this._selectedQuestionList[arg1.type] == undefined) 
            {
                this._selectedQuestionList[arg1.type] = new Array();
            }
            this._selectedQuestionList[arg1.type].push(arg1);
            return;
        }

        public function removeSelectedQuestion(arg1:com.bqt.Question):Boolean
        {
            var loc1:*=null;
            var loc2:*=undefined;
            var loc3:*=null;
            if (this._selectedQuestionList[arg1.type] != undefined) 
            {
                loc1 = this._selectedQuestionList[arg1.type] as Array;
                loc2 = 0;
                while (loc2 < loc1.lengthl) 
                {
                    if ((loc3 = loc1[loc2]).id == arg1.id) 
                    {
                        loc1.splice(loc2, 1);
                        return true;
                    }
                    ++loc2;
                }
            }
            return false;
        }

        public function addSelectedSubQuestion(arg1:int, arg2:int, arg3:String):Boolean
        {
            if (!(this._selectedQuestionList[arg3] == undefined) && this._selectedQuestionList[arg3].length > 0) 
            {
                if (!this.hasSelectedQuestion(arg1)) 
                {
                };
            }
            return false;
        }

        internal static const FLOW_CLOSE_TAG:String="</TextFlow>";

        internal static const FONT_LOOKUP:String=flash.text.engine.FontLookup.DEVICE;

        internal static const FONT_KERNING:String="auto";

        internal static const FLOW_OPEN_TAG:String="<TextFlow color=\"#000000\" columnCount=\"0\" columnGap=\"0\" columnWidth=\"600\" paddingBottom=\"50\" paddingLeft=\"25\" paddingRight=\"25\" paddingTop=\"25\" paragraphSpaceAfter=\"12\" paragraphSpaceBefore=\"0\" verticalAlign=\"top\" whiteSpaceCollapse=\"preserve\" xmlns=\"http://ns.adobe.com/textLayout/2008\">";

        internal static const SPAN_CLOSE_TAG:String="</span>";

        internal static const PARA_CLOSE_TAG:String="</p>";

        internal var _typesData:Array;

        internal var _questionList:Array;

        internal var _chapterToQIdMap:Object;

        internal var _quesTypeToDescMap:Object;

        internal var _selectedQuestionList:Object;

        internal var _sortOrder:Array;

        internal var _testDuration:String;

        internal var _graphicCollection:Object;

        internal var _logoBitmap:flash.display.Bitmap;

        internal var _logoBD:flash.display.BitmapData;

        internal var _testDetail:Object;

        internal var _selectedQCount:Object;

        internal var _autoCreateParams:Object;

        internal var _flowXML:String="";

        internal var _textFlow:flashx.textLayout.elements.TextFlow=null;

        internal static var _instance:com.bqt.DataManager;
    }
}
