package com.bqt 
{
    import flash.display.*;
    import flash.geom.*;
    import flash.text.*;
    
    public class PreviewPage extends flash.display.Sprite
    {
        public function PreviewPage(arg1:int=0)
        {
            super();
            this._copyRgtTxtFld = new flash.text.TextField();
            this._pageNumTxtFld = new flash.text.TextField();
            this.formatTextFld(this._copyRgtTxtFld);
            this.formatTextFld(this._pageNumTxtFld);
            this._copyRgtTxtFld.text = com.bqt.AppConfig.COPYRIGTH_TEXT;
            this._footerArea = new flash.geom.Rectangle(com.bqt.AppConfig.PAGE_MARGINS.LEFT, com.bqt.AppConfig.PAGE_HEIGHT - com.bqt.AppConfig.PAGE_MARGINS.BOTTOM, com.bqt.AppConfig.PAGE_WIDTH - (com.bqt.AppConfig.PAGE_MARGINS.LEFT + com.bqt.AppConfig.PAGE_MARGINS.RIGHT), com.bqt.AppConfig.PAGE_MARGINS.BOTTOM);
            this._copyRgtTxtFld.x = this._footerArea.x;
            var loc1:*;
            this._copyRgtTxtFld.y = loc1 = this._footerArea.y + 5;
            this._pageNumTxtFld.y = loc1;
            addChild(this._copyRgtTxtFld);
            addChild(this._pageNumTxtFld);
            this.pageNumber = arg1;
            return;
        }

        public function get pageNumber():int
        {
            return this._pageNum;
        }

        public function set pageNumber(arg1:int):void
        {
            this._pageNum = arg1;
            this._pageNumTxtFld.width = 10;
            this._pageNumTxtFld.text = "Pg. " + this._pageNum.toString();
            this._pageNumTxtFld.x = this._footerArea.x + this._footerArea.width - this._pageNumTxtFld.width;
            this._copyRgtTxtFld.width = this._footerArea.width - (this._pageNumTxtFld.width + 50);
            return;
        }

        internal function formatTextFld(arg1:flash.text.TextField):void
        {
            arg1.antiAliasType = flash.text.AntiAliasType.ADVANCED;
            arg1.autoSize = flash.text.TextFieldAutoSize.LEFT;
            arg1.background = false;
            arg1.selectable = false;
            arg1.type = flash.text.TextFieldType.DYNAMIC;
            arg1.multiline = true;
            arg1.border = false;
            arg1.defaultTextFormat = com.bqt.AppConfig.getFooterFormat();
            return;
        }

        public function drawBG():void
        {
            this.graphics.clear();
            this.graphics.lineStyle(1, 13421772);
            this.graphics.beginFill(16777215, 1);
            this.graphics.drawRect(0, 0, com.bqt.AppConfig.PAGE_WIDTH, com.bqt.AppConfig.PAGE_HEIGHT);
            this.graphics.endFill();
            this.graphics.lineStyle(2, 0);
            this.graphics.moveTo(this._footerArea.x, this._footerArea.y + 5);
            this.graphics.lineTo(this._footerArea.x + this._footerArea.width, this._footerArea.y + 5);
            this.graphics.endFill();
            return;
        }

        internal var _pageNum:int;

        internal var _copyRgtTxtFld:flash.text.TextField;

        internal var _pageNumTxtFld:flash.text.TextField;

        internal var _footerArea:flash.geom.Rectangle;
    }
}
