package com.bqt 
{
    import com.bqt.utils.*;
    
    public class Question extends Object
    {
        public function Question(arg1:int=-1, arg2:String="undefined")
        {
            super();
            this._id = arg1;
            this._type = arg2;
            this._chapterNo = -1;
            this._qText = "";
            this._marks = 0;
            this._subQlist = new Array();
            this._imgList = new Array();
            this._ansList = new Array();
            return;
        }

        public function getAnswerByIndex(arg1:int):String
        {
            try 
            {
                return this._ansList[arg1].toString();
            }
            catch (er:*)
            {
            };
            return com.bqt.AppConfig.NO_ANS_STRING;
        }

        public function hasEqualAnswers():Boolean
        {
            return this._ansList.length == this._subQlist.length;
        }

        public function addSelectedSubqId(arg1:int):int
        {
            if (!this._selectedChildren) 
            {
                this._selectedChildren = new Array();
            }
            this._selectedChildren.push(arg1);
            return this._selectedChildren.length;
        }

        public function removeSelectedSubqId(arg1:int):int
        {
            if (!this._selectedChildren) 
            {
                return 0;
            }
            if (this._selectedChildren.indexOf(arg1) > -1) 
            {
                this._selectedChildren.splice(this._selectedChildren.indexOf(arg1), 1);
            }
            return this._selectedChildren.length;
        }

        public function hasSelectedSubqId(arg1:int):Boolean
        {
            return this._selectedChildren && this._selectedChildren.indexOf(arg1) > -1;
        }

        public function getSlectedSubqIds():Array
        {
            return this._selectedChildren ? this._selectedChildren.concat() : new Array();
        }

        public function clone():com.bqt.Question
        {
            var loc1:*=new com.bqt.Question();
            loc1.id = this.id;
            loc1.type = this.type;
            loc1.chapterNo = this.chapterNo;
            loc1.questionText = this.questionText;
            loc1.subQuestionList = this.subQuestionList;
            loc1.imageList = this.imageList;
            loc1.answerList = this.answerList;
            return loc1;
        }

        public function toString():String
        {
            var loc2:*=undefined;
            var loc1:*=this._type + " Q: " + this._qText;
            if (this._subQlist && this._subQlist.length > 0) 
            {
                loc2 = 0;
                while (loc2 < this._subQlist.length) 
                {
                    loc1 = loc1 + ("\n" + (loc2 + 1).toString() + ". " + this._subQlist[loc2]);
                    ++loc2;
                }
            }
            if (this._ansList && this._ansList.length > 0) 
            {
                loc1 = loc1 + "\n\n Ans: ";
                loc2 = 0;
                while (loc2 < this._ansList.length) 
                {
                    loc1 = loc1 + this._ansList[loc2];
                    ++loc2;
                }
            }
            return loc1;
        }

        public function getMatchColumns(arg1:Boolean=true):Array
        {
            var loc7:*=undefined;
            var loc8:*=undefined;
            var loc9:*=undefined;
            var loc10:*=null;
            if (this._subQlist.length == 0) 
            {
                return new Array();
            }
            var loc1:*=new Array();
            var loc2:*=new Array();
            var loc3:*=new Array();
            var loc4:*=new Array();
            var loc5:*=this._subQlist.concat();
            var loc6:*=0;
            if (loc5.length == 1) 
            {
                return loc5;
            }
            while (loc5.length) 
            {
                if ((loc10 = loc5.shift().toString().split("`")).length == 2) 
                {
                    loc3.push(loc1.length);
                    loc1.push(loc10[0]);
                    loc2.push(loc10[1]);
                    continue;
                }
                if (!(loc10.length == 1 && loc10[0].toString().indexOf("[img{") > -1)) 
                {
                    continue;
                }
                loc4.push(loc10[0].toString());
            }
            loc3 = com.bqt.utils.GenericUtils.shuffleArray(loc3);
            while (this._ansList.length) 
            {
                this._ansList.shift();
            }
            while (loc3 && loc3.length) 
            {
                loc7 = loc3.shift();
                loc5[loc7] = com.bqt.utils.StringUtils.numberToAlphabet(loc7) + ") " + loc1[loc7] + "`" + (loc7 + 1).toString() + ") " + loc2.shift();
                this._ansList.push((loc7 + 1).toString());
            }
            if (loc5.length == 0) 
            {
                arg1 = false;
            }
            while (loc4.length) 
            {
                loc5.push(com.bqt.utils.StringUtils.numberToAlphabet(loc5.length) + ") " + loc4.shift());
            }
            if (arg1) 
            {
                loc5.unshift("Column I`Column II");
            }
            return loc5;
        }

        public function get id():int
        {
            return this._id;
        }

        public function set id(arg1:int):void
        {
            this._id = arg1;
            return;
        }

        public function get chapterNo():int
        {
            return this._chapterNo;
        }

        public function set chapterNo(arg1:int):void
        {
            this._chapterNo = arg1;
            return;
        }

        public function get marks():Number
        {
            return this._marks;
        }

        public function set marks(arg1:Number):void
        {
            this._marks = arg1;
            return;
        }

        public function get type():String
        {
            return this._type;
        }

        public function set type(arg1:String):void
        {
            this._type = arg1;
            return;
        }

        public function get questionText():String
        {
            return this._qText;
        }

        public function set questionText(arg1:String):void
        {
            this._qText = arg1;
            return;
        }

        public function get subQuestionList():Array
        {
            return new Array().concat(this._subQlist);
        }

        public function set subQuestionList(arg1:Array):void
        {
            this._subQlist = this._subQlist.concat(arg1);
            return;
        }

        public function addSubQuestion(arg1:String):int
        {
            if (!this._subQlist) 
            {
                this._subQlist = new Array();
            }
            this._subQlist.push(arg1);
            return this._subQlist.length;
        }

        public function getSubQuestionByIndex(arg1:int):String
        {
            return this._subQlist[arg1].toString();
        }

        public function hasSubQuestions():Boolean
        {
            return this._subQlist.length > 0;
        }

        public function get imageList():Array
        {
            return this._imgList.concat();
        }

        public function set imageList(arg1:Array):void
        {
            this._imgList = this._imgList.concat(arg1);
            return;
        }

        public function get answerList():Array
        {
            return this._ansList.concat();
        }

        public function set answerList(arg1:Array):void
        {
            this._ansList = this._ansList.concat(arg1);
            return;
        }

        public function addAnsText(arg1:String):int
        {
            this._ansList.push(arg1);
            return this._ansList.length;
        }

        public static const DELIMITER:String="|";

        public static const COLUMN_DELIMITER:String="`";

        internal var _id:int;

        internal var _chapterNo:int;

        internal var _type:String;

        internal var _qText:String;

        internal var _subQlist:Array;

        internal var _imgList:Array;

        internal var _ansList:Array;

        internal var _marks:Number;

        internal var _selectedChildren:Array;
    }
}
