﻿package com.bqt 
{
    import com.bqt.utils.*;
    import fl.containers.*;
    import fl.text.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import flash.net.*;
    import flash.system.*;
    import flash.text.*;
    import flash.utils.*;
    import flashx.textLayout.container.*;
    import flashx.textLayout.conversion.*;
    import flashx.textLayout.elements.*;
    
    public class TestGenerator extends flash.display.Sprite
    {
        public function TestGenerator()
        {
            this.allScreens = [com.bqt.ChapterListScreen, com.bqt.TestDetailsScreen];
            super();
            this.addEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            this._selectedChapters = new Array();
            this._currentFile = "";
            return;
        }

        internal function onLogoFileSelect(arg1:flash.events.Event):void
        {
            this._fileRef.addEventListener(flash.events.Event.COMPLETE, this.onLogoFileLoaded);
            this._fileRef.load();
            return;
        }

        internal function onAddedToStage(arg1:flash.events.Event):void
        {
            var e:flash.events.Event;

            var loc1:*;
            e = arg1;
            this.removeEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            try 
            {
                this._splash = new SplashScreen();
                stage.addChild(this._splash);
                this.tabChildren = false;
                this.visible = false;
                this._uiScreenContainer = new flash.display.Sprite();
                this._uiScreenContainer.x = 202;
                this._uiScreenContainer.y = 50;
                this._uiScreenContainer.mouseEnabled = false;
                this.addChild(this._uiScreenContainer);
                this._dataManager = com.bqt.DataManager.getInstance();
                this._txtBookName = this.getChildByName("bookNameTxt") as flash.text.TextField;
                this.addEventListener(flash.events.MouseEvent.CLICK, this.onMouseClick);
                this.addEventListener(flash.events.Event.CHANGE, this.onSelecttionChanged);
                stage.displayState = flash.display.StageDisplayState.FULL_SCREEN;
                this._breadCrumbMc = this.getChildByName("breadCrumbsMc") as flash.display.MovieClip;
                this.addChild(this._breadCrumbMc);
                com.bqt.MessageBox.setParent(this);
                if (com.bqt.AppConfig.HAS_SEMESTERS) 
                {
                    this._currentFile = "sem1_english.xml";
                }
                else 
                {
                    this._currentFile = com.bqt.AppConfig.DATA_XML;
                }
                this.loadDataXml();
            }
            catch (er:Error)
            {
                this.visible = true;
                com.bqt.MessageBox.show(er.message);
            }
            return;
        }

        internal function loadImage(arg1:String):void
        {
            if (!this._imgLoader) 
            {
                this._imgLoader = new flash.display.Loader();
            }
            this._imgLoader.name = "imagel";
            this._imgLoader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE, this.onImgLoaded);
            this._imgLoader.contentLoaderInfo.addEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onImgError);
            this._imgLoader.contentLoaderInfo.addEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR, this.onImgError);
            this._imgLoader.load(new flash.net.URLRequest(arg1));
            return;
        }

        internal function onImgError(arg1:*=null):void
        {
            this._imgLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE, this.onImgLoaded);
            this._imgLoader.contentLoaderInfo.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onImgError);
            this._imgLoader.contentLoaderInfo.removeEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR, this.onImgError);
            if (arg1) 
            {
                this.visible = true;
                com.bqt.MessageBox.show("Error loading image:\n" + this._imgLoader.contentLoaderInfo.url);
            }
            return;
        }

        internal function onImgLoaded(arg1:flash.events.Event):void
        {
            var e:flash.events.Event;
            var bitmap:flash.display.Bitmap;
            var scale:Number;
            var sp:flash.display.Sprite;
            var bmp:flash.display.Bitmap;
            var f:flash.filters.DropShadowFilter;

            var loc1:*;
            bitmap = null;
            scale = NaN;
            sp = null;
            bmp = null;
            f = null;
            e = arg1;
            try 
            {
                this.onImgError();
                loc2 = this._imgLoader.name;
                switch (loc2) 
                {
                    case "imagel":
                    {
                        if (this._imgLoader.contentLoaderInfo.url && this._imgLoader.contentLoaderInfo.url.indexOf("title.jpg") > -1) 
                        {
                            bmp = e.target.content as flash.display.Bitmap;
                            bmp.scaleX = loc2 = 155 / this._imgLoader.contentLoaderInfo.width;
                            bmp.scaleY = loc2;
                            bmp.x = 17;
                            bmp.y = 161;
                            bmp.smoothing = true;
                            f = new flash.filters.DropShadowFilter(5, 45, 0, 1, 5, 5, 0.5, 1, true);
                            bmp.filters = [f];
                            addChild(bmp);
                            this.loadDataXml();
                        }
                        break;
                    }
                    case "logol":
                    {
                        bitmap = e.target.content as flash.display.Bitmap;
                        scale = Math.min(com.bqt.AppConfig.LOGO_SIZE / this._imgLoader.contentLoaderInfo.width, com.bqt.AppConfig.LOGO_SIZE / this._imgLoader.contentLoaderInfo.height);
                        bitmap.scaleY = loc2 = scale;
                        bitmap.scaleX = loc2;
                        sp = new flash.display.Sprite();
                        sp.graphics.beginFill(16777215, 1);
                        sp.graphics.drawRect(0, 0, com.bqt.AppConfig.LOGO_SIZE, com.bqt.AppConfig.LOGO_SIZE);
                        sp.graphics.endFill();
                        bitmap.x = (com.bqt.AppConfig.LOGO_SIZE - bitmap.width) / 2;
                        bitmap.y = (com.bqt.AppConfig.LOGO_SIZE - bitmap.height) / 2;
                        sp.addChild(bitmap);
                        this._dataManager.setLogoSource(sp);
                        bitmap = this._dataManager.getLogoBitmap();
                        if (bitmap) 
                        {
                            this._testDetailsScreen.addLogo(bitmap);
                        }
                        break;
                    }
                }
            }
            catch (er:Error)
            {
                this.visible = true;
                com.bqt.MessageBox.show(er.message);
            }
            return;
        }

        internal function loadDataXml():void
        {
            this._dataManager.reInit();
            this._xmlLoader = new flash.net.URLLoader();
            this._xmlLoader.addEventListener(flash.events.Event.COMPLETE, this.onXmlLoaded);
            this._xmlLoader.addEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onXmlIoError);
            this._xmlLoader.addEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR, this.onXmlSecurityError);
            this._xmlLoader.load(new flash.net.URLRequest(com.bqt.AppConfig.ASSETS_DIR + "/" + this._currentFile));
            return;
        }

        internal function onXmlIoError(arg1:*=null):void
        {
            this._xmlLoader.removeEventListener(flash.events.Event.COMPLETE, this.onXmlLoaded);
            this._xmlLoader.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onXmlIoError);
            this._xmlLoader.removeEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR, this.onXmlSecurityError);
            if (arg1 != null) 
            {
                this.visible = true;
                com.bqt.MessageBox.show("Error loading data file.\n" + arg1);
            }
            return;
        }

        internal function onXmlSecurityError(arg1:*=null):void
        {
            this.onXmlIoError(arg1);
            return;
        }

        internal function onXmlLoaded(arg1:flash.events.Event):void
        {
            var e:flash.events.Event;
            var dataXml:XML;
            var chapterList:XMLList;
            var i:int;
            var qList:XMLList;
            var chapter:*;
            var qType:String;
            var qText:String;
            var subQtext:Array;
            var qNode:*;
            var subqNode:*;
            var ansNode:*;
            var question:com.bqt.Question;
            var arr:Array;
            var txt:String;

            var loc1:*;
            dataXml = null;
            chapterList = null;
            i = 0;
            qList = null;
            chapter = undefined;
            qType = null;
            qText = null;
            subQtext = null;
            qNode = undefined;
            subqNode = undefined;
            ansNode = undefined;
            question = null;
            arr = null;
            txt = null;
            e = arg1;
            try 
            {
                this.onXmlIoError();
                dataXml = new XML(e.target.data);
                chapterList = dataXml.chapters[0].chapter;
                if (dataXml.bookname[0]) 
                {
                    this._txtBookName.text = dataXml.bookname[0].text();
                }
                this._dataManager.createTypeToDescMap(dataXml.qtypes[0].qtype);
                qList = dataXml.questions[0].question;
                i = 0;
                while (i < qList.length()) 
                {
                    qType = qList[i].@type;
                    chapter = qList[i].@chapter;
                    question = new com.bqt.Question();
                    question.id = i;
                    question.questionText = qList[i].text().toString();
                    question.type = qType;
                    question.chapterNo = int(chapter);
                    if (qList[i].subq[0] != undefined) 
                    {
                        txt = qList[i].subq[0].text().toString();
                        if (txt.split(" ").join("").length > 0) 
                        {
                            question.subQuestionList = txt.split(com.bqt.Question.DELIMITER);
                        }
                    }
                    if (qList[i].images[0] != undefined) 
                    {
                        txt = qList[i].images[0].text().toString();
                        txt = txt.replace(new RegExp("}img]<br \\/>|", "g"), "}img]|");
                        if (txt.split(" ").join("").length > 0) 
                        {
                            question.imageList = txt.split(com.bqt.Question.DELIMITER);
                        }
                    }
                    if (qList[i].ans[0] != undefined) 
                    {
                        txt = qList[i].ans[0].text().toString();
                        if (question.subQuestionList.length == 1 && question.getSubQuestionByIndex(0).indexOf("[img{") > -1) 
                        {
                            txt = txt.split(com.bqt.Question.DELIMITER).join(", ");
                        }
                        if (txt.split(" ").join("").length > 0) 
                        {
                            question.answerList = txt.split(com.bqt.Question.DELIMITER);
                        }
                    }
                    this._dataManager.addQuestion(question);
                    ++i;
                }
                if (!this._testSummaryScreen) 
                {
                    this._testSummaryScreen = new com.bqt.TestSummaryScreen(this._uiScreenContainer);
                    this._uiScreenContainer.addChild(this._testSummaryScreen);
                }
                if (!this._previewScreen) 
                {
                    this._previewScreen = new com.bqt.PreviewScreen(this._uiScreenContainer);
                    this._uiScreenContainer.addChild(this._previewScreen);
                }
                if (!this._autoCreateScreen) 
                {
                    this._autoCreateScreen = new com.bqt.AutoCreateScreen(this._uiScreenContainer);
                    this._uiScreenContainer.addChild(this._autoCreateScreen);
                }
                if (!this._selectQuestionsScreen) 
                {
                    this._selectQuestionsScreen = new com.bqt.SelectQuestionsScreen(this._uiScreenContainer);
                    this._uiScreenContainer.addChild(this._selectQuestionsScreen);
                }
                if (com.bqt.AppConfig.HAS_SEMESTERS) 
                {
                    if (!this._subjectChapterScreen) 
                    {
                        this._subjectChapterScreen = new com.bqt.SubjectChapterScreen(this._uiScreenContainer);
                        this._uiScreenContainer.addChild(this._subjectChapterScreen);
                    }
                    this._subjectChapterScreen.createChapterList(chapterList);
                    this._subjectChapterScreen.bringToFront();
                }
                else 
                {
                    if (!this._chapterListScr) 
                    {
                        this._chapterListScr = new com.bqt.ChapterListScreen(this._uiScreenContainer);
                        this._uiScreenContainer.addChild(this._chapterListScr);
                    }
                    this._chapterListScr.createChapterList(chapterList);
                    this._chapterListScr.bringToFront();
                }
                if (!this._testDetailsScreen) 
                {
                    this._testDetailsScreen = new com.bqt.TestDetailsScreen(this._uiScreenContainer);
                    this._uiScreenContainer.addChild(this._testDetailsScreen);
                }
                this._selectQuestionsScreen.prepare();
                this._selectedChapters = new Array();
                if (!this.visible) 
                {
                    flash.utils.setTimeout(function ():*
                    {
                        arguments[0].visible = true;
                        return;
                    }, 8800, this)
                }
            }
            catch (er:Error)
            {
                trace(er.getStackTrace());
                onXmlIoError(er);
            }
            return;
        }

        internal function onSelecttionChanged(arg1:flash.events.Event):*
        {
            var loc1:*=null;
            var loc2:*=undefined;
            var loc3:*=flash.utils.getQualifiedClassName(arg1.target);
            switch (loc3) 
            {
                case "com.bqt::ChapterRow":
                {
                    loc1 = arg1.target as com.bqt.ChapterRow;
                    if (loc1.selected) 
                    {
                        loc1.showSelectedBG = true;
                        if (this._selectedChapters.indexOf(loc1.chapterNo) == -1) 
                        {
                            this._selectedChapters.push(loc1.chapterNo);
                        }
                    }
                    else 
                    {
                        loc1.showSelectedBG = false;
                        loc2 = this._selectedChapters.indexOf(loc1.chapterNo);
                        if (loc2 > -1) 
                        {
                            this._selectedChapters.splice(loc2, 1);
                        }
                    }
                    break;
                }
                case "fl.controls::CheckBox":
                {
                    loc3 = arg1.target.name;
                    switch (loc3) 
                    {
                        case "chkSelectAllChapters":
                        {
                            this._chapterListScr.selectAllChapters = arg1.target.selected;
                            break;
                        }
                    }
                    break;
                }
                case "com.bqt::CheckBox2":
                {
                    break;
                }
            }
            return;
        }

        internal function onMouseClick(arg1:flash.events.MouseEvent):void
        {
            var loc1:*=undefined;
            var loc2:*=null;
            var loc3:*=null;
            var loc4:*=flash.utils.getQualifiedClassName(arg1.target);
            switch (loc4) 
            {
                case "flash.display::SimpleButton":
                case "fl.controls::Button":
                {
                    loc4 = arg1.target.name;
                    switch (loc4) 
                    {
                        case "btnNextfrmChapters":
                        {
                            if (this._selectedChapters.length < 1) 
                            {
                                com.bqt.MessageBox.show("Please select at least one chapter to proceed.");
                                return;
                            }
                            this._dataManager.setTestDetail("chapters", this._selectedChapters.concat().sort(Array.NUMERIC));
                            this._breadCrumbMc.nextFrame();
                            if (this._createMode != com.bqt.CreateMode.MANUAL) 
                            {
                                this._autoCreateScreen.prepare();
                                this._autoCreateScreen.bringToFront();
                                this._breadCrumbMc.gotoAndStop("auto");
                            }
                            else 
                            {
                                this._selectQuestionsScreen.prepare();
                                this._selectQuestionsScreen.bringToFront();
                                this._breadCrumbMc.gotoAndStop("select");
                            }
                            break;
                        }
                        case "btnNextfrmDetails":
                        {
                            this._testName = this._testDetailsScreen.testName;
                            this._testType = this._testDetailsScreen.testType;
                            this._createMode = this._testDetailsScreen.createMode;
                            this._dataManager.setTestDetail("testName", this._testName);
                            this._dataManager.setTestDetail("createMode", this._createMode);
                            this._dataManager.setTestDetail("testType", this._testType);
                            this._dataManager.setTestDetail("duration", this._testDetailsScreen.testDuration);
                            if (!this._dataManager.getTestDetail("testName")) 
                            {
                                com.bqt.MessageBox.show("Please enter a test name to proceed.");
                                return;
                            }
                            if (!this._dataManager.getTestDetail("duration")) 
                            {
                                com.bqt.MessageBox.show("Please enter test duration to proceed.");
                                return;
                            }
                            if (int(this._testDetailsScreen.testDuration) == 0) 
                            {
                                com.bqt.MessageBox.show("Test duration cannot be 0.");
                                return;
                            }
                            this._dataManager.setTestDetail("duration", com.bqt.utils.StringUtils.formatTime(int(this._testDetailsScreen.testDuration)));
                            if (!this._dataManager.getTestDetail("testType")) 
                            {
                                com.bqt.MessageBox.show("Please select a test type to proceed.");
                                return;
                            }
                            if (!this._dataManager.getTestDetail("createMode")) 
                            {
                                com.bqt.MessageBox.show("Please select a create mode to proceed.");
                                return;
                            }
                            if (this._chapterListScr && this._chapterListScr.stage) 
                            {
                                this._breadCrumbMc.gotoAndStop("chapters");
                                this._chapterListScr.bringToFront();
                            }
                            else if (this._subjectChapterScreen && this._subjectChapterScreen) 
                            {
                                this._breadCrumbMc.gotoAndStop("chapters");
                                this._subjectChapterScreen.bringToFront();
                            }
                            break;
                        }
                        case "btnNextfrmSelect":
                        {							
                            if (this._selectQuestionsScreen.updateSelectedQuestionList()) 
                            {
                                com.bqt.MessageBox.show("", com.bqt.MessageBox.YES_NO);
                            }
                            else 
                            {
                                com.bqt.MessageBox.show("Please select at least one question to procced.");
                            }
                            break;
                        }
                        case "btnNextFromAuto":
                        {
                            if (this._autoCreateScreen.prepareTestQuestions()) 
                            {
                                com.bqt.MessageBox.show("", com.bqt.MessageBox.PROGRESS_INDETERMINATE);
                                this._previewScreen.prepare();
                                this._previewScreen.bringToFront();
                                this._breadCrumbMc.gotoAndStop("preview");
                            }
                            break;
                        }
                        case "btnNextFromPreview":
                        {
                            this._testSummaryScreen.prepare();
                            this._testSummaryScreen.bringToFront();
                            this._breadCrumbMc.gotoAndStop("export");
                            break;
                        }
                        case "btnPrevFrmChapters":
                        {
                            this._breadCrumbMc.gotoAndStop("details");
                            this._testDetailsScreen.bringToFront();
                            break;
                        }
                        case "btnPrevFrmSelect":
                        {
                            this._breadCrumbMc.gotoAndStop("chapters");
                            this._chapterListScr.bringToFront();
                            break;
                        }
                        case "btnPrevFrmAuto":
                        {
                            if (this._dataManager.getTestDetail("createMode") != com.bqt.CreateMode.AUTO) 
                            {
                                this._breadCrumbMc.gotoAndStop("select");
                                this._selectQuestionsScreen.bringToFront();
                            }
                            else 
                            {
                                this._breadCrumbMc.gotoAndStop("chapters");
                                this._chapterListScr.bringToFront();
                            }
                            break;
                        }
                        case "btnPrevFromPreview":
                        {
                            this._breadCrumbMc.gotoAndStop("auto");
                            this._autoCreateScreen.bringToFront();
                            break;
                        }
                        case "btnPrevFrmSummary":
                        {
                            this._breadCrumbMc.gotoAndStop("preview");
                            this._previewScreen.bringToFront();
                            break;
                        }
                        case "btnSaveTest":
                        {
                            com.bqt.MessageBox.show("", com.bqt.MessageBox.PROGRESS_INDETERMINATE);
                            this._testSummaryScreen.exportTest();
                            break;
                        }
                        case "btnSaveNoAnswers":
                        {
                            com.bqt.MessageBox.show("", com.bqt.MessageBox.PROGRESS_INDETERMINATE);
                            this._testSummaryScreen.exportTest(false);
                            break;
                        }
                        case "btnAlertYes":
                        {
                            com.bqt.MessageBox.hide();
                            this._autoCreateScreen.prepare(this._dataManager.getTestDetail("createMode") == com.bqt.CreateMode.AUTO);
                            this._autoCreateScreen.bringToFront();
                            this._breadCrumbMc.gotoAndStop("auto");
                            break;
                        }
                        case "btnAlertNo":
                        {
                            com.bqt.MessageBox.hide();
                            break;
                        }
                        case "btnAlertOk":
                        {
                            com.bqt.MessageBox.hide();
                            break;
                        }
                        case "browseLogo":
                        {
                            this._fileRef = new flash.net.FileReference();
                            loc2 = new Array();
                            loc2.push(new flash.net.FileFilter("Images", "*.jpeg;*.jpg;*.png"));
                            this._fileRef.addEventListener(flash.events.Event.SELECT, this.onLogoFileSelect);
                            this._fileRef.browse(loc2);
                            break;
                        }
                        case "btnStartOver":
                        {
                            loc1 = 0;
                            while (loc1 < this._uiScreenContainer.numChildren) 
                            {
                                if (this._uiScreenContainer.getChildAt(loc1) is com.bqt.ControlScreen) 
                                {
                                    (loc3 = this._uiScreenContainer.getChildAt(loc1) as com.bqt.ControlScreen).reset();
                                }
                                ++loc1;
                            }
                            this._selectedChapters = new Array();
                            this._dataManager.reset();
                            this._breadCrumbMc.gotoAndStop(1);
                            if (com.bqt.AppConfig.HAS_SEMESTERS) 
                            {
                                this._testDetailsScreen.bringToFront();
                            }
                            else 
                            {
                                this._testDetailsScreen.bringToFront();
                            }
                            break;
                        }
                        case "btnSelectData":
                        {
                            if (this._currentFile != this._subjectChapterScreen.selectedFile) 
                            {
                                this._currentFile = this._subjectChapterScreen.selectedFile;
                                this.loadDataXml();
                            }
                            break;
                        }
                        case "exitBtn":
                        {							
							addChild(exitMc);
							exitMc.gotoAndPlay(2);
                            //flash.system.fscommand("quit", "true");
                            break;
                        }
						case "helpBtn":
                        {							
							addChild(helpMc);
							helpMc.gotoAndStop(2);
                            //flash.system.fscommand("quit", "true");
                            break;
                        }
                    }
                    break;
                }
            }
            return;
        }

        internal function onLogoFileLoaded(arg1:flash.events.Event):void
        {
            this._fileRef.removeEventListener(flash.events.Event.COMPLETE, this.onLogoFileLoaded);
            this._fileRef.removeEventListener(flash.events.Event.SELECT, this.onLogoFileSelect);
            if (!this._imgLoader) 
            {
                this._imgLoader = new flash.display.Loader();
            }
            this._imgLoader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE, this.onImgLoaded);
            this._imgLoader.name = "logol";
            this._imgLoader.loadBytes(arg1.target.data);
            return;
        }

        internal function createPreview():void
        {
            var loc1:*="auto";
            var loc2:*="device";
            var loc3:*="<TextFlow color=\"#FF0000\" backgroundColor=\"#FFFFFF\" columnCount=\"0\" columnGap=\"0\" columnWidth=\"600\" paddingBottom=\"50\" paddingLeft=\"25\" paddingRight=\"25\" paddingTop=\"25\" paragraphSpaceAfter=\"0\" paragraphSpaceBefore=\"0\" verticalAlign=\"top\" whiteSpaceCollapse=\"preserve\" xmlns=\"http://ns.adobe.com/textLayout/2008\">";
            var loc4:*="</TextFlow>";
            var loc5:*="<p color=\"#00000\" backgroundColor=\"#FFFFFF\" fontFamily=\"" + com.bqt.AppConfig.APP_FONT_SANSARIF + "\" kerning=\"" + loc1 + "\" textDecoration=\"none\" fontLookup=\"" + loc2 + "\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_BIG + "\" fontWeight=\"bold\" textAlign=\"left\">" + "<span fontStyle=\'normal\'>" + " " + "this is the <br /> <br /><br /><br />new text" + "</span><img source=\"data\\image\\ch1img1.jpg\" height=\"195\" width=\"225\"/>" + "<br /><span textDecoration=\"underline\">Hello World!</span></p>";
            var loc6:*=new flash.display.Sprite();
            this.tf = flashx.textLayout.conversion.TextConverter.importToFlow(new XML(loc3 + loc5 + loc4), flashx.textLayout.conversion.TextConverter.TEXT_LAYOUT_FORMAT);
            this.tf.flowComposer.addController(new flashx.textLayout.container.ContainerController(loc6, 300, 1000));
            this.tf.flowComposer.updateAllControllers();
            loc6.x = 250;
            addChild(loc6);
            var loc7:*;
            (loc7 = new fl.text.TLFTextField()).tlfMarkup = loc3 + loc5 + loc4;
            loc7.autoSize = "left";
            loc7.background = true;
            loc7.border = true;
            addChild(loc7);
            return;
        }

        function update():void
        {
            var loc3:*=null;
            this.tf.flowComposer.updateAllControllers();
            var loc1:*=this.tf.getChildAt(0) as flashx.textLayout.elements.ParagraphElement;
            var loc2:*=0;
            while (loc2 < (loc1.numChildren - 1)) 
            {
                if (loc1.getChildAt(loc2) is flashx.textLayout.elements.InlineGraphicElement) 
                {
                    loc3 = loc1.getChildAt(loc2) as flashx.textLayout.elements.InlineGraphicElement;
                    trace(loc3.actualHeight, loc3.actualWidth, loc3.source);
                }
                ++loc2;
            }
            return;
        }

        public override function set visible(arg1:Boolean):void
        {
            super.visible = arg1;
            this._splash.visible = !arg1;
            return;
        }

        internal var _chapterListScr:com.bqt.ChapterListScreen;

        internal var _testDetailsScreen:com.bqt.TestDetailsScreen;

        internal var _selectQuestionsScreen:com.bqt.SelectQuestionsScreen;

        internal var _previewScreen:com.bqt.PreviewScreen;

        internal var _testSummaryScreen:com.bqt.TestSummaryScreen;

        internal var _chapterScrPane:fl.containers.ScrollPane;

        internal var _subjectChapterScreen:com.bqt.SubjectChapterScreen;

        internal var _imgLoader:flash.display.Loader;

        internal var _fileRef:flash.net.FileReference;

        internal var _txtBookName:flash.text.TextField;

        internal var _currentFile:String;

        public var breadCrumbsMc:flash.display.MovieClip;

        public var exitBtn:flash.display.SimpleButton;

        public var bookNameTxt:flash.text.TextField;

        internal var allScreens:Array;

        internal var _uiScreenContainer:flash.display.Sprite;

        internal var _xmlLoader:flash.net.URLLoader;

        internal var _selectedChapters:Array;

        internal var _selectedQuestionIds:Array;

        internal var _testName:String;

        internal var _testType:String;

        internal var _autoCreateScreen:com.bqt.AutoCreateScreen;

        internal var _createMode:String;

        var tf:flashx.textLayout.elements.TextFlow;

        internal var _dataManager:com.bqt.DataManager;

        internal var _breadCrumbMc:flash.display.MovieClip;

        internal var _splash:SplashScreen;
		
		public var exitMc:flash.display.MovieClip;
		
		public var helpBtn:flash.display.SimpleButton;
		
		public var helpMc:flash.display.MovieClip;
		
    }
}
