﻿package com.bqt 
{
    import com.bqt.utils.*;
    import fl.containers.*;
    import fl.controls.*;
    import flash.display.*;
    import flash.events.*;
    import flash.net.*;
    import flash.text.*;
    import flash.utils.*;
    import flashx.textLayout.elements.*;
    import flashx.textLayout.formats.*;
    import org.RTFlex.*;
    
    public class TestSummaryScreen extends com.bqt.ControlScreen
    {
        public function TestSummaryScreen(arg1:flash.display.DisplayObjectContainer)
        {
            super(arg1);
            var loc1:*=new org.RTFlex.Symbol("-", "#hy#");
            org.RTFlex.RTF.addSymbol(loc1);
            loc1 = new org.RTFlex.Symbol("√", "#tk#");
            loc1.charCode = 10003;
            org.RTFlex.RTF.addSymbol(loc1);
            loc1 = new org.RTFlex.Symbol("∠", "#ang#");
            org.RTFlex.RTF.addSymbol(loc1);
            loc1 = new org.RTFlex.Symbol("⊥", "#per#");
            org.RTFlex.RTF.addSymbol(loc1);
            loc1 = new org.RTFlex.Symbol("Δ", "#del#");
            org.RTFlex.RTF.addSymbol(loc1);
            loc1 = new org.RTFlex.Symbol("π", "#pi#");
            org.RTFlex.RTF.addSymbol(loc1);
            this.__setProp_qSummaryPane_TestSummaryScreen_Layer1_0();
            this.__setProp_btnSaveTest_TestSummaryScreen_Layer1_0();
            this.__setProp_btnStartOver_TestSummaryScreen_Layer1_0();
            this.__setProp_btnSaveNoAnswers_TestSummaryScreen_Layer1_0();
            return;
        }

        protected override function init():void
        {
            super.init();
            this._dataManager = com.bqt.DataManager.getInstance();
            this._detailsTextBox = this.getChildByName("testDetailsTxt") as flash.text.TextField;
            this._quesSummPane = this.getChildByName("qSummaryPane") as fl.containers.ScrollPane;
            this._quesSummPane.setStyle("upSkin", new flash.display.Sprite());
            this._quesSummPane.horizontalScrollPolicy = fl.controls.ScrollPolicy.AUTO;
            this._quesSummPane.setStyle("borderStyle", "inset");
            this._summaryTf = new flash.text.TextField();
            this._summaryTf.autoSize = flash.text.TextFieldAutoSize.LEFT;
            this._summaryTf.width = this._quesSummPane.width - 10;
            this._summaryTf.defaultTextFormat = new flash.text.TextFormat(com.bqt.AppConfig.getApplicationFont(), com.bqt.AppConfig.FONT_SIZE_NORMAL, 7704218, true);
            this._summaryTf.x = 10;
            this._quesSummPane.source = this._summaryTf;
            this.formats = new Object();
            return;
        }

        public override function reset():void
        {
            this._detailsTextBox.text = "";
            this._summaryTf.text = "";
            this._quesSummPane.update();
            return;
        }

        public function prepare():void
        {
            var loc3:*=0;
            this._detailsTextBox.text = "";
            this._detailsTextBox.appendText("Test Name: " + this._dataManager.getTestDetail("testName") + "\n");
            this._detailsTextBox.appendText("Chapter no.: " + this._dataManager.getTestDetail("chapters").join(",") + "\n");
            this._detailsTextBox.appendText("Type: " + (this._dataManager.getTestDetail("testType") != com.bqt.TestType.TEACHER ? "Student\'s copy" : "Teacher\'s copy") + "\n");
            this._detailsTextBox.appendText("Marks: " + this._dataManager.getTestDetail("totalMarks") + "\n");
            this._detailsTextBox.appendText("Duration: " + this._dataManager.getTestDetail("duration"));
            this._summaryTf.text = "";
            var loc1:*=this._dataManager.getOrderedTypes();
            var loc2:*=0;
            while (loc2 < loc1.length) 
            {
                loc3 = this._dataManager.getSelectedQCountByType(loc1[loc2]);
                this._summaryTf.appendText(this._dataManager.getDescFromType(loc1[loc2]) + ":  " + loc3.toString() + "\n\n");
                ++loc2;
            }
            return;
        }

        internal function getDefaultFormat():org.RTFlex.Format
        {
            var loc1:*=new org.RTFlex.Format();
            loc1.font = org.RTFlex.Fonts.ARIAL;
            loc1.align = org.RTFlex.Align.LEFT;
            loc1.backgroundColor = new org.RTFlex.RGB(255, 255, 255);
            loc1.bold = false;
            loc1.italic = false;
            loc1.color = new org.RTFlex.RGB(0, 0, 0);
            loc1.underline = false;
            loc1.fontSize = com.bqt.AppConfig.FONT_SIZE_NORMAL;
            return loc1;
        }

        internal function createFormats():void
        {
            this.formats = new Object();
            var loc1:*=this.getDefaultFormat();
            this.formats.default = loc1;
            loc1 = this.getDefaultFormat();
            loc1.bold = true;
            this.formats.defaultBold = loc1;
            loc1 = this.getDefaultFormat();
            loc1.italic = true;
            this.formats.defaultItalic = loc1;
            loc1 = this.getDefaultFormat();
            loc1.underline = true;
            this.formats.defaultUnderline = loc1;
            loc1 = this.getDefaultFormat();
            loc1.fontSize = com.bqt.AppConfig.FONT_SIZE_MEDIUM;
            this.formats.medium = loc1;
            loc1 = this.getDefaultFormat();
            loc1.fontSize = com.bqt.AppConfig.FONT_SIZE_MEDIUM;
            loc1.bold = true;
            this.formats.mediumBold = loc1;
            return;
        }

        internal function getTextFormat(arg1:Number=12, arg2:Boolean=false, arg3:Boolean=false, arg4:String="left"):org.RTFlex.Format
        {
            var loc1:*;
            (loc1 = this.getDefaultFormat()).fontSize = arg1;
            loc1.bold = arg2;
            loc1.italic = arg3;
            loc1.align = arg4;
            return loc1;
        }

        public function exportTest(arg1:Boolean=true):void
        {
            this._showAnswers = arg1;
            flash.utils.setTimeout(this.exportTestInt, 250);
            return;
        }

        internal function exportTestInt():void
        {
            var format:org.RTFlex.Format;
            var para:flashx.textLayout.elements.ParagraphElement;
            var span:flashx.textLayout.elements.SpanElement;
            var igl:flashx.textLayout.elements.InlineGraphicElement;
            var imgLoader:flash.display.Loader;
            var spanId:String;
            var i:*;
            var n:*;
            var fr:org.RTFlex.Format;
            var isPara:Boolean;
            var paraColor:org.RTFlex.RGB;
            var txt:String;
            var s:org.RTFlex.Symbol;
            var r:RegExp;
            var ig:flashx.textLayout.elements.InlineGraphicElement;
            var ba:flash.utils.ByteArray;

            var loc1:*;
            format = null;
            para = null;
            span = null;
            igl = null;
            imgLoader = null;
            spanId = null;
            i = undefined;
            n = undefined;
            fr = null;
            isPara = false;
            paraColor = null;
            txt = null;
            s = null;
            r = null;
            ig = null;
            ba = null;
            try 
            {
                this._textFlow = this._dataManager.getTextFlow();
                this._rtf = null;
                if (!(this._textFlow == null) && this._textFlow.numChildren > 0) 
                {
                    this._rtf = new org.RTFlex.RTF();
                    this._rtf.marginBottom = loc2 = 720;
                    this._rtf.marginTop = loc2;
                    this._rtf.marginRight = loc2 = 720;
                    this._rtf.marginLeft = loc2;
                    this._rtf.pageNumbering = false;
                    this._rtf.setFooterText(com.bqt.RTFTemplates.getPageFooter2(com.bqt.AppConfig.COPYRIGTH_TEXT));
                    format = this.getDefaultFormat();
                    isPara = false;
                    i = 1;
                    while (i < this._textFlow.numChildren) 
                    {
                        para = this._textFlow.getChildAt(i) as flashx.textLayout.elements.ParagraphElement;
                        paraColor = new org.RTFlex.RGB(0, 0, 0);
                        if (para.numChildren > 0) 
                        {
                            if (!this._showAnswers && para.id && para.id.indexOf("_ans_") > -1) 
                            {
                                this._rtf.addLineBreak();
                                this._rtf.addLineBreak();
                            }
                            else 
                            {
                                if (para.id && para.id.indexOf("_ans_") > -1) 
                                {
                                    paraColor = new org.RTFlex.RGB(204, 0, 0);
                                    this._rtf.addLineBreak();
                                    isPara = true;
                                }
                                n = 0;
                                while (n < para.numChildren) 
                                {
                                    isPara = false;
                                    //if (para.id && para.id == "test_header") 
									if (para.id) 
                                    {
                                        if (this._dataManager.getLogoBitmap()) 
                                        {
                                            this._rtf.setTestDetails(com.bqt.RTFTemplates.getFirstPageHeaderWithLogo(this._rtf.encodeJPGToBase64(this.getGraphicBitmapData("logo_img")), String(this._dataManager.getTestDetail("testName")), String(this._dataManager.getTestDetail("totalMarks")), String(this._dataManager.getTestDetail("duration")), String(this._dataManager.getTestDetail("chapters").join(",")), this._dataManager.getTestDetail("testType") == com.bqt.TestType.TEACHER));
                                        }
                                        else 
                                        {
                                            this._rtf.setTestDetails(com.bqt.RTFTemplates.getFirstPageHeader(String(this._dataManager.getTestDetail("testName")), String(this._dataManager.getTestDetail("totalMarks")), String(this._dataManager.getTestDetail("duration")), String(this._dataManager.getTestDetail("chapters").join(",")), this._dataManager.getTestDetail("testType") == com.bqt.TestType.TEACHER));
                                        }
                                    }
                                    if (para.getChildAt(n) is flashx.textLayout.elements.SpanElement) 
                                    {
                                        span = para.getChildAt(n) as flashx.textLayout.elements.SpanElement;
                                        if (span.id && span.id.indexOf("cat_") > -1) 
                                        {
                                            this._rtf.addLineBreak();
                                            isPara = true;
                                        }
                                        if (span.id && span.id.indexOf("_qtext_") > -1) 
                                        {
                                            this._rtf.addLineBreak();
                                        }
                                        txt = com.bqt.utils.StringUtils.decode(span.text);
                                        if (txt.replace(new RegExp(" ", "g"), "").length) 
                                        {
                                        };
                                        txt = txt.replace(new RegExp(" ", "gi"), "\n");
                                        loc2 = 0;
                                        var loc3:*=org.RTFlex.RTF.getSymbolCollection();
                                        for each (s in loc3) 
                                        {
                                            r = new RegExp(s.symbolChar, "g");
                                            txt = txt.replace(r, s.aliasPattern);
                                        }
                                        if (!span.fontFamily) 
                                        {
                                            span.fontFamily = com.bqt.AppConfig.APP_FONT_SANSARIF;
                                        }
                                        fr = new org.RTFlex.Format();
                                        fr.font = span.fontFamily || org.RTFlex.Fonts.ARIAL;
                                        fr.color = paraColor;
                                        fr.fontSize = span.fontSize == undefined ? int(para.fontSize) : int(span.fontSize);
                                        if (fr.fontSize == 12) 
                                        {
                                            fr.fontSize = com.bqt.AppConfig.FONT_SIZE_NORMAL;
                                        }
                                        //fr.underline = span.textDecoration == "underline";
                                        fr.italic = span.fontStyle == "italic";
                                        fr.bold = span.fontWeight == "bold";
                                        fr.align = span.textAlign == undefined ? para.textAlign : span.textAlign;
                                        fr.subScript = span.baselineShift && span.baselineShift == flashx.textLayout.formats.BaselineShift.SUBSCRIPT;
                                        fr.superScript = span.baselineShift && span.baselineShift == flashx.textLayout.formats.BaselineShift.SUPERSCRIPT;
                                        fr.lineSpacing = 1.8;
                                        fr.makeParagraph = isPara;
                                        this._rtf.writeText(txt, fr);
                                    }
                                    else if (para.getChildAt(n) is flashx.textLayout.elements.InlineGraphicElement) 
                                    {
                                        ig = para.getChildAt(n) as flashx.textLayout.elements.InlineGraphicElement;
                                        if (ig.id) 
                                        {
                                            this._rtf.addBitmap(this.getGraphicBitmapData(ig.id));
                                        }
                                        if (n == (para.numChildren - 1)) 
                                        {
                                            this._rtf.addLineBreak();
                                            this._rtf.addLineBreak();
                                        }
                                    }
                                    if (n == (para.numChildren - 1) && para.id && (para.id.indexOf("_ques_") > -1 || para.id.indexOf("_ans_") > -1)) 
                                    {
                                        this._rtf.addLineBreak();
                                    }
                                    ++n;
                                }
                            }
                        }
                        ++i;
                    }
                }
                if (this._rtf != null) 
                {
                    ba = this._rtf.getRTFBytes();
                    this.saveFile(ba);
                }
            }
            catch (er:Error)
            {
                com.bqt.MessageBox.show("Error: " + er.message);
            }
            return;
        }

        internal function getGraphicBitmapData(arg1:String):flash.display.BitmapData
        {
            var loc2:*=null;
            var loc1:*=null;
            try 
            {
                loc2 = this._dataManager.getGraphicFromCollection(arg1);
                if (loc2) 
                {
                    loc1 = new flash.display.BitmapData(loc2.width, loc2.height, false, 16777215);
                    loc1.draw(loc2);
                }
            }
            catch (er:*)
            {
            };
            return loc1;
        }

        internal function saveFile(arg1:flash.utils.ByteArray):void
        {
            var bytes:flash.utils.ByteArray;
            var testType:String;

            var loc1:*;
            testType = null;
            bytes = arg1;
            try 
            {
                com.bqt.MessageBox.hide();
                this._fileRef = new flash.net.FileReference();
                this._fileRef.addEventListener(flash.events.Event.COMPLETE, this.onFileSave);
                this._fileRef.addEventListener(flash.events.Event.SELECT, this.onFileSelect);
                this._fileRef.addEventListener(flash.events.Event.CANCEL, this.onCancel);
                this._fileRef.addEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onSaveError);
                testType = this._dataManager.getTestDetail("testType");
                if (!this._showAnswers) 
                {
                    testType = testType + "_no_ans";
                }
                this._fileRef.save(bytes, this._dataManager.getTestDetail("testName") + "_" + testType + ".doc");
            }
            catch (er:Error)
            {
                trace(er);
                com.bqt.MessageBox.show("Error: " + er.message);
            }
            return;
        }

        internal function onFileSelect(arg1:flash.events.Event):void
        {
            com.bqt.MessageBox.show("", com.bqt.MessageBox.PROGRESS_INDETERMINATE);
            trace("File Select" + arg1.currentTarget);
            return;
        }

        internal function onFileSave(arg1:flash.events.Event):void
        {
            com.bqt.MessageBox.show("Cheers! Your test paper \'" + this._dataManager.getTestDetail("testName") + "\' has been successfully saved.");
            this._fileRef = null;
            return;
        }

        internal function onCancel(arg1:flash.events.Event):void
        {
            trace("File save select canceled.");
            com.bqt.MessageBox.hide();
            this._fileRef = null;
            return;
        }

        internal function onSaveError(arg1:flash.events.IOErrorEvent):void
        {
            com.bqt.MessageBox.show("Error Saving File :\n" + arg1.text);
            this._fileRef = null;
            return;
        }

        function __setProp_qSummaryPane_TestSummaryScreen_Layer1_0():*
        {
            try 
            {
                this.qSummaryPane["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.qSummaryPane.enabled = true;
            this.qSummaryPane.horizontalLineScrollSize = 4;
            this.qSummaryPane.horizontalPageScrollSize = 0;
            this.qSummaryPane.horizontalScrollPolicy = "off";
            this.qSummaryPane.scrollDrag = false;
            this.qSummaryPane.source = "";
            this.qSummaryPane.verticalLineScrollSize = 4;
            this.qSummaryPane.verticalPageScrollSize = 0;
            this.qSummaryPane.verticalScrollPolicy = "auto";
            this.qSummaryPane.visible = true;
            try 
            {
                this.qSummaryPane["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_btnSaveTest_TestSummaryScreen_Layer1_0():*
        {
            try 
            {
                this.btnSaveTest["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.btnSaveTest.emphasized = true;
            this.btnSaveTest.enabled = true;
            this.btnSaveTest.label = "Save Test (.doc)";
            this.btnSaveTest.labelPlacement = "top";
            this.btnSaveTest.selected = false;
            this.btnSaveTest.toggle = false;
            this.btnSaveTest.visible = true;
            try 
            {
                this.btnSaveTest["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_btnStartOver_TestSummaryScreen_Layer1_0():*
        {
            try 
            {
                this.btnStartOver["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.btnStartOver.emphasized = false;
            this.btnStartOver.enabled = true;
            this.btnStartOver.label = "Restart";
            this.btnStartOver.labelPlacement = "top";
            this.btnStartOver.selected = false;
            this.btnStartOver.toggle = false;
            this.btnStartOver.visible = true;
            try 
            {
                this.btnStartOver["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_btnSaveNoAnswers_TestSummaryScreen_Layer1_0():*
        {
            try 
            {
                this.btnSaveNoAnswers["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.btnSaveNoAnswers.emphasized = false;
            this.btnSaveNoAnswers.enabled = true;
            this.btnSaveNoAnswers.label = "Save without Answers";
            this.btnSaveNoAnswers.labelPlacement = "bottom";
            this.btnSaveNoAnswers.selected = false;
            this.btnSaveNoAnswers.toggle = false;
            this.btnSaveNoAnswers.visible = true;
            try 
            {
                this.btnSaveNoAnswers["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        public var btnSaveTest:fl.controls.Button;

        public var testDetailsTxt:flash.text.TextField;

        public var qSummaryPane:fl.containers.ScrollPane;

        public var btnPrevFrmSummary:flash.display.SimpleButton;

        public var btnStartOver:fl.controls.Button;

        public var btnSaveNoAnswers:fl.controls.Button;

        internal var _quesSummPane:fl.containers.ScrollPane;

        internal var _saveBtn:fl.controls.Button;

        internal var _startOverBtn:fl.controls.Button;

        internal var _detailsTextBox:flash.text.TextField;

        internal var _dataManager:com.bqt.DataManager;

        internal var _textFlow:flashx.textLayout.elements.TextFlow;

        internal var _rtf:org.RTFlex.RTF;

        internal var formats:Object;

        internal var _rtfBytes:flash.utils.ByteArray;

        internal var _fileRef:flash.net.FileReference;

        internal var _summaryTf:flash.text.TextField;

        internal var _showAnswers:Boolean=true;
    }
}
