package org.RTFlex 
{
    import mx.utils.*;
    
    public class TableElement extends Object
    {
        public function TableElement(arg1:Number, arg2:Number)
        {
            super();
            this.rows = arg1;
            this.cols = arg2;
            this.tableRows = new Array();
            return;
        }

        public function addRow(arg1:Array):void
        {
            this.tableRows.push(arg1);
            return;
        }

        public function getRTFCode():String
        {
            var loc3:*=0;
            var loc4:*=0;
            var loc5:*=0;
            var loc1:*="\\par";
            var loc2:*=0;
            while (loc2 < this.rows) 
            {
                if (!(this.tableRows[loc2] == null) && this.tableRows[loc2] is Array) 
                {
                    loc1 = loc1 + "\\trowd\\trautofit1\\intbl";
                    loc3 = 0;
                    while (loc3 < this.cols) 
                    {
                        loc1 = loc1 + "\\clbrdrt\\brdrs\\brdrw10\\clbrdrl\\brdrs\\brdrw10\\clbrdrb\\brdrs\\brdrw10\\clbrdrr\\brdrs\\brdrw10";
                        loc1 = loc1 + ("\\cellx" + (loc3 + 1).toString());
                        ++loc3;
                    }
                    loc1 = loc1 + "{";
                    loc4 = 0;
                    while (loc4 < this.cols) 
                    {
                        if (this.tableRows[loc2][loc4] != null) 
                        {
                            loc1 = loc1 + mx.utils.StringUtil.trim(this.getRTFSafeText(this.tableRows[loc2][loc4]));
                        }
                        loc1 = loc1 + "\\cell ";
                        ++loc4;
                    }
                    loc1 = loc1 + " }";
                    loc1 = loc1 + "{\\trowd\\trautofit1\\intbl";
                    loc5 = 0;
                    while (loc5 < this.cols) 
                    {
                        loc1 = loc1 + ("\\cellx" + (loc5 + 1).toString());
                        ++loc5;
                    }
                    loc1 = loc1 + "\\row }";
                }
                ++loc2;
            }
            loc1 = loc1 + "\\pard";
            return loc1;
        }

        internal function getRTFSafeText(arg1:String):String
        {
            var loc2:*=null;
            var loc3:*=null;
            var loc1:*=arg1;
            loc1.split("\\").join("\\\\");
            loc1.split("{").join("\\{");
            loc1.split("}").join("\\}");
            loc1.split("~").join("\\~");
            loc1.split("-").join("\\-");
            loc1.split("_").join("\\_");
            loc1 = loc1.split("\n\r").join(" \\line ");
            loc1 = loc1.split("\n").join(" \\line ");
            loc1 = loc1.split("\r").join(" \\line ");
            loc1 = loc1.split("\t").join(" \\tab ");
            var loc4:*=0;
            var loc5:*=org.RTFlex.RTF.getSymbolCollection();
            for each (loc2 in loc5) 
            {
                loc3 = new RegExp(loc2.aliasPattern, "g");
                loc1 = loc1.replace(loc3, loc2.getRTFCode());
            }
            return loc1;
        }

        public var rows:Number=0;

        public var cols:Number=0;

        internal var tableRows:Array;
    }
}
