package com.bqt 
{
    import com.bqt.fonts.*;
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    
    public class CategoryDetailsRow extends flash.display.Sprite
    {
        public function CategoryDetailsRow(arg1:Number=600)
        {
            this._ar = new com.bqt.fonts.CalibriRegular();
            this._tf = new flash.text.TextFormat(new com.bqt.fonts.ArialRegular().fontName, 14, 0, false, false, false, null, null, "center", 5, 5);
            this._tf2 = new flash.text.TextFormat(com.bqt.AppConfig.getApplicationFont(), 13, com.bqt.AppConfig.CHAPTER_ROW_FONT_COLOR, true, false, false, null, null, "left", 5, 5);
            super();
            this.__width = arg1;
            this.tabEnabled = false;
            this.tabChildren = true;
            this._tfNumQues = new flash.text.TextField();
            this._tfMarks = new flash.text.TextField();
            var loc1:*;
            this._tfNumQues.type = loc1 = flash.text.TextFieldType.INPUT;
            this._tfMarks.type = loc1;
            this._txtCategory = new flash.text.TextField();
            this._txtCategory.x = this._padding * 2;
            this._tfMarks.y = loc1 = int(this._padding * 1.5);
            this._tfNumQues.y = loc1 = loc1;
            this._txtCategory.y = loc1;
            this._tfMarks.width = loc1 = 40;
            this._tfNumQues.width = loc1;
            this._tfMarks.x = this.__width - (this._tfMarks.width + this._padding * 3);
            this._tfNumQues.x = this._tfMarks.x - this._padding * 3 - this._tfMarks.width;
            this._txtCategory.width = this._tfNumQues.x - this._padding * 5;
            this._tfMarks.maxChars = loc1 = 3;
            this._tfNumQues.maxChars = loc1;
            this._tfNumQues.restrict = "[0-9]";
            this._tfMarks.restrict = "[0-9], \".\"";
            this._tfNumQues.border = loc1 = true;
            this._tfMarks.border = loc1;
            this._tfMarks.borderColor = com.bqt.AppConfig.CHAPTER_ROW_BORDER_COLOR;
            this._tfNumQues.borderColor = com.bqt.AppConfig.CHAPTER_ROW_BORDER_COLOR;
            this._tfNumQues.background = loc1 = true;
            this._tfMarks.background = loc1;
            this._tfNumQues.multiline = loc1 = false;
            this._tfMarks.multiline = loc1;
            this._tfNumQues.wordWrap = loc1 = false;
            this._tfMarks.wordWrap = loc1;
            this._tfMarks.name = "tfMarks";
            this._tfNumQues.name = "tfCount";
            this._tfMarks.defaultTextFormat = this._tf;
            this._tfNumQues.defaultTextFormat = this._tf;
            this._tfMarks.height = loc1 = 25;
            this._tfNumQues.height = loc1;
            this._txtCategory.border = false;
            this._txtCategory.autoSize = flash.text.TextFieldAutoSize.LEFT;
            this._txtCategory.multiline = true;
            this._txtCategory.wordWrap = true;
            this._txtCategory.defaultTextFormat = this._tf2;
            addChild(this._tfMarks);
            addChild(this._tfNumQues);
            addChild(this._txtCategory);
            this.drawBG();
            this.reset();
            this.description = "Default Category";
            this.index = 0;
            this._tfMarks.addEventListener(flash.events.Event.CHANGE, this.onTextChange);
            this._tfNumQues.addEventListener(flash.events.Event.CHANGE, this.onTextChange);
            return;
        }

        internal function onTextChange(arg1:*):void
        {
            flash.text.TextField(arg1.target).backgroundColor = 16777215;
            dispatchEvent(new flash.events.Event("params_changed", true, true));
            return;
        }

        public function set description(arg1:String):void
        {
            this._desc = arg1;
            this._txtCategory.text = this._desc;
            this.drawBG(com.bqt.AppConfig.CHAPTER_ROW_BG_COLOR);
            return;
        }

        public function get description():String
        {
            return this._desc;
        }

        public function set type(arg1:String):void
        {
            this._type = arg1;
            return;
        }

        public function get type():String
        {
            return this._type;
        }

        public function set marks(arg1:Number):void
        {
            this._marks = arg1;
            this._tfMarks.text = this._marks.toString();
            return;
        }

        public function get marks():Number
        {
            return Number(this._tfMarks.text);
        }

        public function set qCount(arg1:Number):void
        {
            this._count = arg1;
            this._tfNumQues.text = this._count.toString();
            return;
        }

        public function get qCount():Number
        {
            return Number(this._tfNumQues.text);
        }

        public function set editable(arg1:Boolean):void
        {
            if (arg1) 
            {
                this._tfNumQues.backgroundColor = 16777215;
                this._tfNumQues.type = flash.text.TextFieldType.INPUT;
            }
            else 
            {
                this._tfNumQues.backgroundColor = 15198183;
                this._tfNumQues.type = flash.text.TextFieldType.DYNAMIC;
            }
            return;
        }

        public function get editable():Boolean
        {
            return !(this._tfNumQues.type == flash.text.TextFieldType.DYNAMIC);
        }

        public function set index(arg1:int):void
        {
            this._tfNumQues.tabIndex = arg1 * 2;
            this._tfMarks.tabIndex = this._tfNumQues.tabIndex + 1;
            return;
        }

        public function get index():int
        {
            return this._tfNumQues.tabIndex / 2;
        }

        internal function setTextField(arg1:flash.text.TextField):void
        {
            this._tfNumQues.multiline = false;
            this._tfNumQues.wordWrap = false;
            return;
        }

        public function reset():void
        {
            this.marks = 0;
            this.qCount = 0;
            return;
        }

        public function getHeight():Number
        {
            return Math.max(this._tfNumQues.height, this._txtCategory.textHeight) + int(this._padding * 3);
        }

        public function validate():Boolean
        {
            if (!this._tfMarks.length) 
            {
                this._tfMarks.backgroundColor = 16711680;
                return false;
            }
            if (!this._tfNumQues.length) 
            {
                this._tfNumQues.backgroundColor = 16711680;
                return false;
            }
            return true;
        }

        internal function drawBG(arg1:uint=13421772):void
        {
            var loc1:*=this.getHeight();
            this.graphics.clear();
            this.graphics.beginFill(arg1, 1);
            this.graphics.drawRect(0, 0, this.__width + 10, loc1);
            this.graphics.endFill();
            this.graphics.lineStyle(1, com.bqt.AppConfig.CHAPTER_ROW_BORDER_COLOR, 1);
            this.graphics.moveTo(0, loc1);
            this.graphics.lineTo(this.__width + 10, loc1);
            this._txtCategory.y = (loc1 - this._txtCategory.textHeight) / 2;
            this._tfNumQues.y = (loc1 - this._tfNumQues.height) / 2;
            this._tfMarks.y = (loc1 - this._tfMarks.height) / 2;
            return;
        }

        internal var _tfNumQues:flash.text.TextField;

        internal var _tfMarks:flash.text.TextField;

        internal var _txtCategory:flash.text.TextField;

        internal var _ar:com.bqt.fonts.CalibriRegular;

        internal var _tf:flash.text.TextFormat;

        internal var _tf2:flash.text.TextFormat;

        internal var _padding:int=5;

        internal var __width:Number;

        internal var __height:Number;

        internal var _desc:String="";

        internal var _type:String="";

        internal var _marks:Number=0;

        internal var _count:Number=0;
    }
}
