﻿package com.bqt 
{
    import fl.containers.*;
    import flash.display.*;
    
    public class ChapterListScreen extends com.bqt.ControlScreen
    {
        public function ChapterListScreen(arg1:flash.display.DisplayObjectContainer=null)
        {
            super(arg1);
            this.__setProp_chapterListPane_ChapterListScreen_Layer1_0();
            return;
        }

        protected override function init():void
        {
            super.init();
            this._listParent = new flash.display.Sprite();
            this._scrPane = this.getChildByName("chapterListPane") as fl.containers.ScrollPane;
            this._scrPane.setSize(770, 389);
            this._scrPane.source = this._listParent;
            this._scrPane.invalidate();
            return;
        }

        public function createChapterList(arg1:XMLList):void
        {
            var loc1:*=null;
            var loc2:*=null;
            while (this._listParent.numChildren) 
            {
                this._listParent.removeChildAt(0);
            }
            this._scrPane.update();
            var loc3:*=0;
            while (loc3 < arg1.length()) 
            {
                loc1 = new com.bqt.ChapterRow(this._scrPane.width - 15);
                loc1.backgroundColor = com.bqt.AppConfig.CHAPTER_ROW_BG_COLOR;
                loc1.foregroundColor = com.bqt.AppConfig.CHAPTER_ROW_FONT_COLOR;
                loc2 = arg1[loc3].@num;
                loc1.name = "chapter_" + loc2;
                loc1.chapterNo = int(loc2);
                loc1.label = loc2 + ". " + arg1[loc3].@name;
                loc1.y = 1 + (loc1.height + 1) * loc3;
                loc1.x = 1;
                this._listParent.addChild(loc1);
                ++loc3;
            }
            this._scrPane.update();
            return;
        }

        public override function reset():void
        {
            var loc1:*=0;
            while (loc1 < this._listParent.numChildren) 
            {
                if (this._listParent.getChildAt(loc1) is com.bqt.ChapterRow) 
                {
                    (this._listParent.getChildAt(loc1) as com.bqt.ChapterRow).selected = false;
                }
                ++loc1;
            }
            return;
        }

        public function set selectAllChapters(arg1:Boolean):void
        {
            var loc1:*=0;
            while (loc1 < this._listParent.numChildren) 
            {
                if (this._listParent.getChildAt(loc1) is com.bqt.ChapterRow) 
                {
                    (this._listParent.getChildAt(loc1) as com.bqt.ChapterRow).selected = arg1;
                }
                ++loc1;
            }
            return;
        }

        function __setProp_chapterListPane_ChapterListScreen_Layer1_0():*
        {
            try 
            {
                this.chapterListPane["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.chapterListPane.enabled = true;
            this.chapterListPane.horizontalLineScrollSize = 4;
            this.chapterListPane.horizontalPageScrollSize = 0;
            this.chapterListPane.horizontalScrollPolicy = "off";
            this.chapterListPane.scrollDrag = false;
            this.chapterListPane.source = "";
            this.chapterListPane.verticalLineScrollSize = 4;
            this.chapterListPane.verticalPageScrollSize = 0;
            this.chapterListPane.verticalScrollPolicy = "auto";
            this.chapterListPane.visible = true;
            try 
            {
                this.chapterListPane["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        public var btnPrevFrmChapters:flash.display.SimpleButton;

        public var btnNextfrmChapters:flash.display.SimpleButton;

        public var chapterListPane:fl.containers.ScrollPane;

        internal var _listParent:flash.display.Sprite;

        internal var _scrPane:fl.containers.ScrollPane;
    }
}
