package com.bqt 
{
    import com.bqt.fonts.*;
    import fl.controls.*;
    import flash.text.*;
    
    public class ChapterRow extends fl.controls.CheckBox
    {
        public function ChapterRow(arg1:Number=650, arg2:Number=27)
        {
            this.font = new com.bqt.fonts.CalibriRegular();
            this.tf = new flash.text.TextFormat(this.font.fontName, 14, 16776960, false);
            super();
            this.setSize(arg1, arg2);
            this.labelPlacement = "left";
            this._textField = new flash.text.TextField();
            this._textField.autoSize = "left";
            this._textField.defaultTextFormat = this.tf;
            addChild(this._textField);
            this.label = "Chapter 0";
            this.backgroundColor = 16776960;
            this.foregroundColor = 16777215;
            return;
        }

        public override function get label():String
        {
            return this._textField.text;
        }

        public override function set label(arg1:String):void
        {
            super.label = "";
            this._textField.text = arg1;
            this._textField.x = 10;
            this._textField.y = (this.height - this._textField.height) / 2;
            return;
        }

        public override function setSize(arg1:Number, arg2:Number):void
        {
            super.setSize(arg1, arg2);
            this.showSelectedBG = false;
            return;
        }

        public function get realWidth():Number
        {
            return this.width + 10;
        }

        public function set backgroundColor(arg1:uint):void
        {
            this._bgColor = arg1;
            this.showSelectedBG = false;
            return;
        }

        public function set foregroundColor(arg1:uint):void
        {
            this._textField.textColor = arg1;
            return;
        }

        public function get chapterNo():int
        {
            return this._chapNo;
        }

        public function set chapterNo(arg1:int):void
        {
            this._chapNo = arg1;
            return;
        }

        public function set showSelectedBG(arg1:Boolean):void
        {
            if (arg1) 
            {
                this.drawBG(com.bqt.AppConfig.CHAPTER_ROW_SELECTED_COLOR);
            }
            else 
            {
                this.drawBG(this._bgColor);
            }
            return;
        }

        internal function drawBG(arg1:uint):void
        {
            this.graphics.clear();
            this.graphics.beginFill(arg1);
            this.graphics.drawRect(0, 0, this.realWidth, this.height);
            this.graphics.endFill();
            this.graphics.lineStyle(1, com.bqt.AppConfig.CHAPTER_ROW_BORDER_COLOR, 1);
            this.graphics.moveTo(0, this.height);
            this.graphics.lineTo(this.realWidth, this.height);
            return;
        }

        internal var font:com.bqt.fonts.CalibriRegular;

        internal var tf:flash.text.TextFormat;

        internal var _textField:flash.text.TextField;

        internal var __height:Number=10;

        internal var _bgColor:uint=0;

        internal var _chapNo:int;
    }
}
