﻿package com.bqt 
{
    import com.bqt.utils.*;
    import fl.containers.*;
    import fl.controls.*;
    import flash.display.*;
    import flash.events.*;
    import flash.net.*;
    import flash.utils.*;
    import flashx.textLayout.elements.*;
    
    public class PreviewScreen extends com.bqt.ControlScreen
    {
        public function PreviewScreen(arg1:flash.display.DisplayObjectContainer)
        {
            super(arg1);
            this.__setProp_previewPane_PreviewScreen_Layer1_0();
            return;
        }

        public function prepare():void
        {
            flash.utils.setTimeout(this.prepareInternal, 100);
            return;
        }

        internal function prepareInternal():void
        {
            var para:flashx.textLayout.elements.ParagraphElement;
            var span:flashx.textLayout.elements.SpanElement;
            var igl:flashx.textLayout.elements.InlineGraphicElement;
            var imgLoader:flash.display.Loader;
            var i:*;
            var n:*;

            var loc1:*;
            para = null;
            span = null;
            igl = null;
            imgLoader = null;
            i = undefined;
            n = undefined;
            try 
            {
                this.reset();
                this._textFlow = this._dataManager.getTextFlow(true);
                this._iglCollection = new Array();
                if (this._textFlow && this._textFlow.numChildren > 0) 
                {
                    i = 0;
                    while (i < this._textFlow.numChildren) 
                    {
                        para = this._textFlow.getChildAt(i) as flashx.textLayout.elements.ParagraphElement;
                        if (para.numChildren > 0) 
                        {
                            n = 0;
                            while (n < para.numChildren) 
                            {
                                if (para.getChildAt(n) is flashx.textLayout.elements.SpanElement) 
                                {
                                    span = para.getChildAt(n) as flashx.textLayout.elements.SpanElement;
                                    span.text = com.bqt.utils.StringUtils.decode(span.text);
                                    if (span.id && span.id.indexOf("match_") > -1) 
                                    {
                                        span.text = span.text.replace(new RegExp("`", "g"), "\t" + com.bqt.AppConfig.MATCH_SEPARATOR + "\t");
                                    }
                                    else if (span.id && span.id.indexOf("_ans_") > -1) 
                                    {
                                        span = span.getNextSibling() as flashx.textLayout.elements.SpanElement;
                                        span.fontStyle = "italic";
                                        span.paddingTop = com.bqt.AppConfig.FONT_SIZE_SMALL;
                                    }
                                }
                                else if (para.getChildAt(n) is flashx.textLayout.elements.InlineGraphicElement) 
                                {
                                    igl = para.getChildAt(n) as flashx.textLayout.elements.InlineGraphicElement;
                                    if (igl.id && igl.id == "logo_img") 
                                    {
                                        igl.source = this._dataManager.getLogoBitmap();
                                        this._dataManager.addToGraphicCollection(igl.id, this._dataManager.getLogoBitmap());
                                    }
                                    else 
                                    {
                                        igl.id = "img_" + n.toString() + "_" + i.toString();
                                        this._iglCollection.push(igl);
                                    }
                                }
                                ++n;
                            }
                        }
                        ++i;
                    }
                    this.loadImages();
                }
            }
            catch (er:*)
            {
                com.bqt.MessageBox.hide();
            }
            return;
        }

        internal function loadImages():void
        {
            var loc1:*;
            try 
            {
                if (this._iglCollection.length > 0) 
                {
                    if (!this._imgLoader) 
                    {
                        this._imgLoader = new flash.display.Loader();
                    }
                    this._imgLoader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE, this.onImgLoadComplete);
                    this._imgLoader.contentLoaderInfo.addEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onImgIoError);
                    this._imgLoader.contentLoaderInfo.addEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR, this.onImgSecurityError);
                    this._currentIgl = this._iglCollection.shift();
                    this._imgLoader.name = this._currentIgl.id;
                    this._imgLoader.load(new flash.net.URLRequest(this._currentIgl.source.toString()));
                }
                else 
                {
                    this.addPages();
                }
            }
            catch (er:*)
            {
                com.bqt.MessageBox.hide();
            }
            return;
        }

        function __setProp_previewPane_PreviewScreen_Layer1_0():*
        {
            try 
            {
                this.previewPane["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.previewPane.enabled = true;
            this.previewPane.horizontalLineScrollSize = 4;
            this.previewPane.horizontalPageScrollSize = 0;
            this.previewPane.horizontalScrollPolicy = "off";
            this.previewPane.scrollDrag = false;
            this.previewPane.source = "";
            this.previewPane.verticalLineScrollSize = 4;
            this.previewPane.verticalPageScrollSize = 0;
            this.previewPane.verticalScrollPolicy = "auto";
            this.previewPane.visible = true;
            try 
            {
                this.previewPane["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        internal function getTextSpanOpenTag(arg1:String=""):String
        {
            return "<span color=\"#000000\" id=\"" + arg1 + "\" backgroundcolor=\"#FFFFFF\" fontFamily=\"" + com.bqt.AppConfig.APP_FONT_SANSARIF + "\" kerning=\"" + FONT_KERNING + "\" textDecoration=\"none\" fontLookup=\"" + FONT_LOOKUP + "\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_NORMAL + "\" fontWeight=\"normal\" textAlign=\"left\">";
        }

        internal function getTextParaOpenTag(arg1:String=""):String
        {
            return "<p color=\"#000000\" id=\"" + arg1 + "\" backgroundcolor=\"#FFFFFF\" fontFamily=\"" + com.bqt.AppConfig.APP_FONT_SANSARIF + "\" kerning=\"" + FONT_KERNING + "\" textDecoration=\"none\" fontLookup=\"" + FONT_LOOKUP + "\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_NORMAL + "\" fontWeight=\"normal\" textAlign=\"left\">";
        }

        internal function getCategoryParaOpenTag(arg1:String=""):String
        {
            return "<p color=\"#000000\" id=\"" + arg1 + "\" backgroundcolor=\"#FFFFFF\" fontFamily=\"" + com.bqt.AppConfig.APP_FONT_SANSARIF + "\" kerning=\"" + FONT_KERNING + "\" textDecoration=\"none\" fontLookup=\"" + FONT_LOOKUP + "\" fontSize=\"" + com.bqt.AppConfig.FONT_SIZE_MEDIUM + "\" fontWeight=\"bold\" textAlign=\"left\">";
        }

        public override function reset():void
        {
            while (this._iglCollection.length) 
            {
                this._iglCollection.shift();
            }
            while (this._pageContainer.numChildren) 
            {
                this._pageContainer.removeChildAt(0);
            }
            this._previewPane.verticalScrollPosition = 0;
            this._previewPane.update();
            this._dataManager.clearGraphicCollection();
            return;
        }

        internal function addPages():void
        {
            var loc1:*=null;
            var loc2:*=null;
            var loc3:*=undefined;
            try 
            {
                this._textFlow.flowComposer.updateAllControllers();
                loc1 = new com.bqt.PreviewPage(this._pageContainer.numChildren + 1);
                loc1.y = (com.bqt.AppConfig.PAGE_HEIGHT + 20) * this._pageContainer.numChildren;
                this._pageContainer.addChild(loc1);
                loc2 = new com.bqt.PreviewTextController(loc1, com.bqt.AppConfig.PAGE_WIDTH, com.bqt.AppConfig.PAGE_HEIGHT);
                loc2.pageNumber = loc1.pageNumber;
                this._textFlow.flowComposer.addController(loc2);
                this._textFlow.flowComposer.updateAllControllers();
                loc1.drawBG();
                this._previewPane.update();
                if (loc1.numChildren > 3) 
                {
                    this.addPages();
                }
                else 
                {
                    loc3 = 0;
                    while (loc3 < this._pageContainer.numChildren) 
                    {
                        if (this._pageContainer.getChildAt(loc3) is com.bqt.PreviewPage) 
                        {
                            loc1 = this._pageContainer.getChildAt(loc3) as com.bqt.PreviewPage;
                            loc1.drawBG();
                            if (loc1.numChildren < 3) 
                            {
                                this._pageContainer.removeChildAt(loc3);
                                this._previewPane.update();
                                --loc3;
                            }
                        }
                        ++loc3;
                    }
                }
            }
            catch (er:*)
            {
            };
            com.bqt.MessageBox.hide();
            return;
        }

        internal function onImgLoadComplete(arg1:flash.events.Event):void
        {
            var loc1:*=null;
            try 
            {
                loc1 = arg1.target.content as flash.display.Bitmap;
                if (loc1) 
                {
                    loc1.scaleY = loc2 = Math.min(arg1.target.width, 720) / arg1.target.width;
                    loc1.scaleX = loc2;
                    loc1.smoothing = true;
                    this._currentIgl.width = Math.ceil(loc1.width);
                    this._currentIgl.height = Math.ceil(loc1.height);
                    this._currentIgl.source = loc1;
                    this._dataManager.addToGraphicCollection(this._currentIgl.id, loc1);
                }
            }
            catch (er:Error)
            {
            };
            this.loadImages();
            return;
        }

        internal function onImgSecurityError(arg1:*):void
        {
            this.onImgIoError(arg1);
            return;
        }

        internal function onImgIoError(arg1:*=null):void
        {
            this._imgLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE, this.onImgLoadComplete);
            this._imgLoader.contentLoaderInfo.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onImgIoError);
            this._imgLoader.contentLoaderInfo.removeEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR, this.onImgSecurityError);
            if (arg1) 
            {
                trace(arg1);
            }
            this.loadImages();
            return;
        }

        protected override function init():void
        {
            super.init();
            this._dataManager = com.bqt.DataManager.getInstance();
            this._pageContainer = new flash.display.Sprite();
            this._previewPane = this.getChildByName("previewPane") as fl.containers.ScrollPane;
            this._previewPane.horizontalScrollPolicy = fl.controls.ScrollPolicy.OFF;
            this._previewPane.scrollDrag = false;
            this._previewPane.source = this._pageContainer;
            this._previewPane.update();
            this._bgSkin = new flash.display.Sprite();
            this._bgSkin.graphics.clear();
            this._bgSkin.graphics.beginFill(10066329, 1);
            this._bgSkin.graphics.drawRect(0, 0, this._previewPane.width, this._previewPane.height);
            this._bgSkin.graphics.endFill();
            this._previewPane.setStyle("upSkin", this._bgSkin);
            this._pageContainer.x = (this._previewPane.width - 10 - com.bqt.AppConfig.PAGE_WIDTH) / 2;
            this._iglCollection = new Array();
            return;
        }

        internal static const FLOW_OPEN_TAG:String="<TextFlow color=\"#000000\" columnCount=\"0\" columnGap=\"0\" columnWidth=\"600\" paddingBottom=\"50\" paddingLeft=\"25\" paddingRight=\"25\" paddingTop=\"25\" paragraphSpaceAfter=\"10\" paragraphSpaceBefore=\"0\" verticalAlign=\"top\" whiteSpaceCollapse=\"preserve\" xmlns=\"http://ns.adobe.com/textLayout/2008\">";

        internal static const SPAN_CLOSE_TAG:String="</span>";

        internal static const PARA_CLOSE_TAG:String="</p>";

        internal static const FLOW_CLOSE_TAG:String="</TextFlow>";

        internal static const FONT_LOOKUP:String="device";

        internal static const FONT_KERNING:String="auto";

        public var btnPrevFromPreview:flash.display.SimpleButton;

        public var previewPane:fl.containers.ScrollPane;

        public var btnNextFromPreview:flash.display.SimpleButton;

        internal var _iglCollection:Array;

        internal var _pageContainer:flash.display.Sprite;

        internal var _previewPane:fl.containers.ScrollPane;

        internal var _selectedQuestions:Object;

        internal var _dataManager:com.bqt.DataManager;

        var _currentIgl:flashx.textLayout.elements.InlineGraphicElement;

        internal var _bgSkin:flash.display.Sprite;

        internal var _imgLoader:flash.display.Loader;

        internal var _flowXML:String;

        internal var _textFlow:flashx.textLayout.elements.TextFlow;

        var _lineCount:int;
    }
}
