﻿package com.bqt 
{
    import com.bqt.utils.*;
    import fl.containers.*;
    import fl.controls.*;
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    
    public class SelectQuestionsScreen extends com.bqt.ControlScreen
    {
        public function SelectQuestionsScreen(arg1:flash.display.DisplayObjectContainer)
        {
            super(arg1);
            this.__setProp_quesListPane_SelectQuestionsScreen_Layer1_0();
            this.__setProp_btnUpdateList_SelectQuestionsScreen_Layer1_0();
            return;
        }

        protected override function init():void
        {
            super.init();
            this._dataManager = com.bqt.DataManager.getInstance();
            this._selectedType = "";
            this._questionListContainer = new flash.display.Sprite();
            this._questionListContainer.mouseEnabled = false;
            this._cmbSelectType = this.getChildByName("comboSelectType") as fl.controls.ComboBox;
            this._scrollPane = this.getChildByName("quesListPane") as fl.containers.ScrollPane;
            this._scrollPane.source = this._questionListContainer;
            this._scrollPane.invalidate();
            this._selectBtn = this.getChildByName("btnUpdateList") as fl.controls.Button;
            this._qCountTxt = this.getChildByName("qCountTxt") as flash.text.TextField;
            this._selectBtn.addEventListener(flash.events.MouseEvent.CLICK, this.updateQuestionList, false, 0, true);
            this._rowCollection = new Object();
            this._qCountTxt.text = "0";
            this.addEventListener(com.bqt.TestGenEvent.QUESTION_SELECTION_CHANGED, this.onQSelectionChanged);
            return;
        }

        internal function onQSelectionChanged(arg1:com.bqt.TestGenEvent):void
        {
            this.getQCount();
            return;
        }

        public function setSelctedChapters(arg1:Object):void
        {
            this._selctedChapters = arg1;
            return;
        }

        public function prepare():void
        {
            this.reset();
            this._cmbSelectType.dataProvider = this._dataManager.getQuestionTypeDataProvider();
            this._typeToQidMap = null;
            return;
        }

        internal function updateQuestionList(arg1:flash.events.MouseEvent=null):void
        {
            var e:flash.events.MouseEvent=null;
            var cr:com.bqt.ContentRow;
            var totalHeight:Number;
            var i:*;
            var col:Array;
            var qlist:Array;
            var ques:com.bqt.Question;
            var subcr:com.bqt.ContentRow;
            var _content:String;
            var subQtext:*;
            var n:*;

            var loc1:*;
            cr = null;
            totalHeight = NaN;
            i = undefined;
            col = null;
            qlist = null;
            ques = null;
            subcr = null;
            _content = null;
            subQtext = undefined;
            n = undefined;
            e = arg1;
            try 
            {
                if (e) 
                {
                    e.stopImmediatePropagation();
                    e.stopPropagation();
                }
                this._qCountTxt.text = "0";
                if (!this._typeToQidMap) 
                {
                    this._typeToQidMap = this._dataManager.getQuestionIdList(this._dataManager.getTestDetail("chapters"), ["*"]);
                }
                if (this._selectedType == this._cmbSelectType.selectedItem.data) 
                {
                    return;
                }
                this._selectedType = this._cmbSelectType.selectedItem.data;
                while (this._questionListContainer.numChildren > 0) 
                {
                    this._questionListContainer.removeChildAt(0);
                }
                totalHeight = 0;
                if (this._typeToQidMap[this._selectedType] == undefined) 
                {
                    cr = new com.bqt.ContentRow(this._scrollPane.width - 10, 20);
                    this._questionListContainer.addChild(cr);
                    cr.displayType = com.bqt.ContentRow.TYPE_NO_DATA;
                    cr.content = "[img{src=\"no_data.jpg\" height=\"282\" width=\"723\"}img]";
                    cr.y = totalHeight;
                    this._scrollPane.update();
                    return;
                }
                this._cmbSelectType.enabled = true;
                cr = new com.bqt.ContentRow(this._scrollPane.width - 10, 20);
                this._questionListContainer.addChild(cr);
                cr.displayType = com.bqt.ContentRow.TYPE_HEADER;
                cr.content = this._dataManager.getDescFromType(this._selectedType);
                cr.y = totalHeight;
                totalHeight = totalHeight + (cr.getHeight() + 10);
                if (this._rowCollection[this._selectedType] != undefined) 
                {
                    col = this._rowCollection[this._selectedType];
                    i = 0;
                    while (i < col.length) 
                    {
                        this._questionListContainer.addChild(col[i]);
                        ++i;
                    }
                    this._scrollPane.update();
                    this.getQCount();
                    return;
                }
                this._rowCollection[this._selectedType] = new Array();
                col = this._rowCollection[this._selectedType];
                com.bqt.ContentRow.TOTAL_IMAGES = 0;
                qlist = this._typeToQidMap[this._selectedType];
                i = 0;
                while (i < qlist.length) 
                {
                    ques = this._dataManager.getQuestionById(qlist[i]);
                    cr = new com.bqt.ContentRow(this._scrollPane.width - 10, 20);
                    this._questionListContainer.addChild(cr);
                    cr.parentId = i + 1;
                    cr.id = ques.id;
                    cr.questionType = ques.type;
                    cr.displayType = com.bqt.ContentRow.TYPE_PARENT;
                    cr.answers = ques.answerList;
                    cr.content = ques.questionText;
                    totalHeight = totalHeight + 20;
                    cr.y = totalHeight;
                    totalHeight = totalHeight + (cr.getHeight() + 10);
                    col.push(cr);
                    if (ques.subQuestionList.length > 0) 
                    {
                        subQtext = ques.subQuestionList;
                        n = 0;
                        while (n < subQtext.length) 
                        {
                            subcr = new com.bqt.ContentRow(this._scrollPane.width - 30, 20);
                            this._questionListContainer.addChild(subcr);
                            subcr.displayType = com.bqt.ContentRow.TYPE_CHILD;
                            subcr.id = n;
                            subcr.parentId = cr.id;
                            subcr.questionType = ques.type;
                            subcr.parentRow = cr;
                            _content = subQtext[n];
                            subcr.content = _content;
                            subcr.x = 20;
                            subcr.y = totalHeight;
                            totalHeight = totalHeight + (subcr.getHeight() + 10);
                            cr.addChildRow(subcr);
                            col.push(subcr);
                            ++n;
                        }
                    }
                    ++i;
                }
                this.getQCount();
                this._scrollPane.update();
                this._cmbSelectType.enabled = true;
            }
            catch (er:Error)
            {
                trace("Error loading questions. " + er);
                _cmbSelectType.enabled = true;
            }
            return;
        }

        public function updateSelectedQuestionList():Boolean
        {
            var _loc_2:* = null;
            var _loc_3:* = undefined;
            var _loc_4:* = null;
            var _loc_5:* = null;
            var _loc_6:* = null;
            this._dataManager.clearSelectedQuestions();
            var _loc_1:* = 0;
			var _loc_8:*=this._rowCollection;
            for (_loc_2 in _loc_8)
            {
                
                _loc_4 = _loc_8[_loc_2];
                if (_loc_4 && _loc_4.length > 0)
                {
                    _loc_3 = 0;
                    while (_loc_3 < _loc_4.length)
                    {
                        
                        _loc_6 = this.createQuestionFromRow(_loc_4[_loc_3]);
                        if (_loc_6)
                        {
                            _loc_6.marks = this._dataManager.getMarksByType(_loc_6.type);
                            this._dataManager.addSelectedQuestion(_loc_6);
                            _loc_1++;
                        }
                        _loc_3 = _loc_3 + 1;
                    }
                }
            }
            return _loc_1 > 0;
        }

        internal function createQuestionFromRow(arg1:com.bqt.ContentRow):com.bqt.Question
        {
            var loc3:*=null;
            var loc4:*=undefined;
            var loc5:*=null;
            var loc6:*=undefined;
            var loc7:*=null;
            var loc1:*=null;
            var loc2:*=0;
            if (arg1.displayType == com.bqt.ContentRow.TYPE_PARENT) 
            {
                if (arg1.isSelected) 
                {
                    ++loc2;
                }
                loc1 = new com.bqt.Question();
                loc1.questionText = arg1.content;
                loc1.type = arg1.questionType;
                if ((loc3 = arg1.getChildRows()).length > 0) 
                {
                    loc4 = 0;
                    while (loc4 < loc3.length) 
                    {
                        if ((loc5 = loc3[loc4]).isSelected) 
                        {
                            ++loc2;
                            loc6 = com.bqt.utils.StringUtils.numberToAlphabet(loc1.subQuestionList.length) + ") ";
                            loc1.addSubQuestion(loc5.content);
                            loc7 = arg1.getAnswerAt(loc4);
                            loc1.addAnsText(loc7);
                        }
                        ++loc4;
                    }
                }
                else 
                {
                    loc1.answerList = arg1.answers;
                }
            }
            return loc2 > 0 ? loc1 : null;
        }

        public override function reset():void
        {
            var loc1:*=null;
            this._selectedType = "";
            this._qCountTxt.text = "0";
            while (this._questionListContainer.numChildren > 0) 
            {
                this._questionListContainer.removeChildAt(0);
            }
            var loc2:*=0;
            var loc3:*=this._rowCollection;
            for (loc1 in loc3) 
            {
                while (this._rowCollection[loc1].length) 
                {
                    this._rowCollection[loc1].shift();
                }
            }
            this._rowCollection = new Object();
            return;
        }

        internal function getQCount():void
        {
            var totalQs:int;
            var r:com.bqt.ContentRow;
            var i:*;
            var colArray:Array;
            var childRows:Array;
            var cld:com.bqt.ContentRow;

            var loc1:*;
            r = null;
            i = undefined;
            colArray = null;
            childRows = null;
            cld = null;
            totalQs = 0;
            try 
            {
                colArray = this._rowCollection[this._selectedType];
                if (colArray && colArray.length > 0) 
                {
                    i = 0;
                    while (i < colArray.length) 
                    {
                        r = colArray[i] as com.bqt.ContentRow;
                        if (r.displayType == com.bqt.ContentRow.TYPE_PARENT) 
                        {
                            childRows = r.getChildRows();
                            if (!childRows.length && r.isSelected) 
                            {
                                ++totalQs;
                            }
                            else 
                            {
                                loc2 = 0;
                                var loc3:*=childRows;
                                for each (cld in loc3) 
                                {
                                    if (!cld.isSelected) 
                                    {
                                        continue;
                                    }
                                    ++totalQs;
                                }
                            }
                        }
                        ++i;
                    }
                }
            }
            catch (er:*)
            {
                totalQs = 0;
            }
            this._dataManager.setQCountByType(this._selectedType, totalQs);
            this._dataManager.setSelectedQCountByType(this._selectedType, totalQs);
            this._qCountTxt.text = totalQs.toString();
            return;
        }

        function __setProp_quesListPane_SelectQuestionsScreen_Layer1_0():*
        {
            try 
            {
                this.quesListPane["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.quesListPane.enabled = true;
            this.quesListPane.horizontalLineScrollSize = 4;
            this.quesListPane.horizontalPageScrollSize = 0;
            this.quesListPane.horizontalScrollPolicy = "off";
            this.quesListPane.scrollDrag = false;
            this.quesListPane.source = "";
            this.quesListPane.verticalLineScrollSize = 4;
            this.quesListPane.verticalPageScrollSize = 0;
            this.quesListPane.verticalScrollPolicy = "auto";
            this.quesListPane.visible = true;
            try 
            {
                this.quesListPane["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_btnUpdateList_SelectQuestionsScreen_Layer1_0():*
        {
            try 
            {
                this.btnUpdateList["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.btnUpdateList.emphasized = false;
            this.btnUpdateList.enabled = true;
            this.btnUpdateList.label = "OK";
            this.btnUpdateList.labelPlacement = "right";
            this.btnUpdateList.selected = false;
            this.btnUpdateList.toggle = false;
            this.btnUpdateList.visible = true;
            try 
            {
                this.btnUpdateList["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        public var quesListPane:fl.containers.ScrollPane;

        public var btnPrevFrmSelect:flash.display.SimpleButton;

        public var qCountTxt:flash.text.TextField;

        public var btnNextfrmSelect:flash.display.SimpleButton;

        public var btnUpdateList:fl.controls.Button;

        public var comboSelectType:fl.controls.ComboBox;

        internal var _selectBtn:fl.controls.Button;

        internal var _cmbSelectType:fl.controls.ComboBox;

        internal var _selectedType:String;

        internal var _questionListContainer:flash.display.Sprite;

        internal var _scrollPane:fl.containers.ScrollPane;

        internal var _selctedChapters:Object;

        internal var _dataManager:com.bqt.DataManager;

        internal var _typeToQidMap:Object;

        internal var _rowCollection:Object;

        internal var _qCountTxt:flash.text.TextField;
    }
}
