package com.bqt 
{
    import fl.containers.*;
    import fl.controls.*;
    import fl.data.*;
    import flash.display.*;
    
    public class SubjectChapterScreen extends com.bqt.ControlScreen
    {
        public function SubjectChapterScreen(arg1:flash.display.DisplayObjectContainer)
        {
            super(arg1);
            this.__setProp_chapterListPane_SubjectChapterScreen_Layer1_0();
            this.__setProp_btnNextfrmChapters_SubjectChapterScreen_Layer1_0();
            this.__setProp_btnSelectData_SubjectChapterScreen_Layer1_0();
            this.__setProp_cbSubject_SubjectChapterScreen_Layer1_0();
            this.__setProp_cbSemester_SubjectChapterScreen_Layer1_0();
            return;
        }

        protected override function init():void
        {
            super.init();
            this._listParent = new flash.display.Sprite();
            this._cmbSemester = this.getChildByName("cbSemester") as fl.controls.ComboBox;
            this._cmbSubject = this.getChildByName("cbSubject") as fl.controls.ComboBox;
            this._scrPane = this.getChildByName("chapterListPane") as fl.containers.ScrollPane;
            this._scrPane.setSize(650, 300);
            this._scrPane.source = this._listParent;
            this._scrPane.invalidate();
            return;
        }

        public function createChapterList(arg1:XMLList):void
        {
            var loc1:*=null;
            var loc2:*=null;
            while (this._listParent.numChildren) 
            {
                this._listParent.removeChildAt(0);
            }
            this._scrPane.update();
            var loc3:*=0;
            while (loc3 < arg1.length()) 
            {
                loc1 = new com.bqt.ChapterRow(625);
                loc1.backgroundColor = 16251131;
                loc1.foregroundColor = 8293526;
                loc2 = arg1[loc3].@num;
                loc1.name = "chapter_" + loc2;
                loc1.chapterNo = int(loc2);
                loc1.label = loc2 + ". " + arg1[loc3].@name;
                loc1.y = 1 + (loc1.height + 2) * loc3;
                loc1.x = 1;
                this._listParent.addChild(loc1);
                ++loc3;
            }
            this._scrPane.update();
            return;
        }

        public override function reset():void
        {
            var loc1:*=0;
            while (loc1 < this._listParent.numChildren) 
            {
                if (this._listParent.getChildAt(loc1) is com.bqt.ChapterRow) 
                {
                    (this._listParent.getChildAt(loc1) as com.bqt.ChapterRow).selected = false;
                }
                ++loc1;
            }
            return;
        }

        public function set selectAllChapters(arg1:Boolean):void
        {
            var loc1:*=0;
            while (loc1 < this._listParent.numChildren) 
            {
                if (this._listParent.getChildAt(loc1) is com.bqt.ChapterRow) 
                {
                    (this._listParent.getChildAt(loc1) as com.bqt.ChapterRow).selected = arg1;
                }
                ++loc1;
            }
            return;
        }

        public function get selectedFile():String
        {
            return this._cmbSemester.selectedItem.data + "_" + this._cmbSubject.selectedItem.data + ".xml";
        }

        function __setProp_chapterListPane_SubjectChapterScreen_Layer1_0():*
        {
            try 
            {
                this.chapterListPane["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.chapterListPane.enabled = true;
            this.chapterListPane.horizontalLineScrollSize = 4;
            this.chapterListPane.horizontalPageScrollSize = 0;
            this.chapterListPane.horizontalScrollPolicy = "off";
            this.chapterListPane.scrollDrag = false;
            this.chapterListPane.source = "";
            this.chapterListPane.verticalLineScrollSize = 4;
            this.chapterListPane.verticalPageScrollSize = 0;
            this.chapterListPane.verticalScrollPolicy = "auto";
            this.chapterListPane.visible = true;
            try 
            {
                this.chapterListPane["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_btnNextfrmChapters_SubjectChapterScreen_Layer1_0():*
        {
            try 
            {
                this.btnNextfrmChapters["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.btnNextfrmChapters.emphasized = false;
            this.btnNextfrmChapters.enabled = true;
            this.btnNextfrmChapters.label = "Next";
            this.btnNextfrmChapters.labelPlacement = "left";
            this.btnNextfrmChapters.selected = false;
            this.btnNextfrmChapters.toggle = false;
            this.btnNextfrmChapters.visible = true;
            try 
            {
                this.btnNextfrmChapters["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_btnSelectData_SubjectChapterScreen_Layer1_0():*
        {
            try 
            {
                this.btnSelectData["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.btnSelectData.emphasized = false;
            this.btnSelectData.enabled = true;
            this.btnSelectData.label = "Select";
            this.btnSelectData.labelPlacement = "left";
            this.btnSelectData.selected = false;
            this.btnSelectData.toggle = false;
            this.btnSelectData.visible = true;
            try 
            {
                this.btnSelectData["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_cbSubject_SubjectChapterScreen_Layer1_0():*
        {
            var loc2:*=null;
            var loc3:*=null;
            var loc4:*=null;
            var loc5:*=0;
            var loc6:*=undefined;
            try 
            {
                this.cbSubject["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            var loc1:*=new fl.data.DataProvider();
            loc3 = [{"label":"English", "data":"english"}, {"label":"Evs", "data":"evs"}, {"label":"Mathematics", "data":"maths"}];
            loc5 = 0;
            while (loc5 < loc3.length) 
            {
                loc2 = new fl.data.SimpleCollectionItem();
                loc4 = loc3[loc5];
                loc7 = 0;
                var loc8:*=loc4;
                for (loc6 in loc8) 
                {
                    loc2[loc6] = loc4[loc6];
                }
                loc1.addItem(loc2);
                ++loc5;
            }
            this.cbSubject.dataProvider = loc1;
            this.cbSubject.editable = false;
            this.cbSubject.enabled = true;
            this.cbSubject.prompt = "";
            this.cbSubject.restrict = "";
            this.cbSubject.rowCount = 5;
            this.cbSubject.visible = true;
            try 
            {
                this.cbSubject["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_cbSemester_SubjectChapterScreen_Layer1_0():*
        {
            var loc2:*=null;
            var loc3:*=null;
            var loc4:*=null;
            var loc5:*=0;
            var loc6:*=undefined;
            try 
            {
                this.cbSemester["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            var loc1:*=new fl.data.DataProvider();
            loc3 = [{"label":"Semester 1", "data":"sem1"}, {"label":"Semester 2", "data":"sem2"}];
            loc5 = 0;
            while (loc5 < loc3.length) 
            {
                loc2 = new fl.data.SimpleCollectionItem();
                loc4 = loc3[loc5];
                loc7 = 0;
                var loc8:*=loc4;
                for (loc6 in loc8) 
                {
                    loc2[loc6] = loc4[loc6];
                }
                loc1.addItem(loc2);
                ++loc5;
            }
            this.cbSemester.dataProvider = loc1;
            this.cbSemester.editable = false;
            this.cbSemester.enabled = true;
            this.cbSemester.prompt = "";
            this.cbSemester.restrict = "";
            this.cbSemester.rowCount = 2;
            this.cbSemester.visible = true;
            try 
            {
                this.cbSemester["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        public var cbSemester:fl.controls.ComboBox;

        public var cbSubject:fl.controls.ComboBox;

        public var btnNextfrmChapters:fl.controls.Button;

        public var btnSelectData:fl.controls.Button;

        public var chapterListPane:fl.containers.ScrollPane;

        internal var _listParent:flash.display.Sprite;

        internal var _scrPane:fl.containers.ScrollPane;

        internal var _cmbSemester:fl.controls.ComboBox;

        internal var _cmbSubject:fl.controls.ComboBox;
    }
}
