package com.bqt 
{
    import fl.controls.*;
    import fl.data.*;
    import flash.display.*;
    
    public class TestDetailsScreen extends com.bqt.ControlScreen
    {
        public function TestDetailsScreen(arg1:flash.display.DisplayObjectContainer)
        {
            super(arg1);
            this.__setProp_browseLogo_TestDetailsScreen_Layer1_0();
            this.__setProp_cbTestType_TestDetailsScreen_Layer1_0();
            this.__setProp_cbTestMode_TestDetailsScreen_Layer1_0();
            this.__setProp_txtBoxTestName_TestDetailsScreen_Layer1_0();
            this.__setProp_txtTestDuration_TestDetailsScreen_Layer1_0();
            return;
        }

        protected override function init():void
        {
            super.init();
            this._txtTestName = this.getChildByName("txtBoxTestName") as fl.controls.TextInput;
            this._comboCreateMode = this.getChildByName("cbTestMode") as fl.controls.ComboBox;
            this._comboTestType = this.getChildByName("cbTestType") as fl.controls.ComboBox;
            this._txtTestDuration = this.getChildByName("txtTestDuration") as fl.controls.TextInput;
            this._browseBtn = this.getChildByName("browseLogo") as fl.controls.Button;
            this._logoContainer = this.getChildByName("logoContainer") as flash.display.MovieClip;
            this._txtTestName.restrict = "[0-9],[a-z],[A-Z], \" \", \"_\"";
            this.reset();
            return;
        }

        public override function reset():void
        {
            this._txtTestName.text = "";
            this._txtTestDuration.text = "";
            this._comboCreateMode.selectedIndex = -1;
            this._comboTestType.selectedIndex = -1;
            while (this._logoContainer.numChildren > 1) 
            {
                this._logoContainer.removeChildAt(1);
            }
            return;
        }

        public function addLogo(arg1:flash.display.DisplayObject):void
        {
            arg1.x = (this._logoContainer.width - arg1.width) / 2;
            arg1.y = (this._logoContainer.height - arg1.height) / 2;
            this._logoContainer.addChild(arg1);
            return;
        }

        public function get testDuration():String
        {
            return this._txtTestDuration.text;
        }

        public function get testName():String
        {
            return this._txtTestName.text;
        }

        public function get createMode():String
        {
            if (this._comboCreateMode.selectedIndex == 0) 
            {
                return com.bqt.CreateMode.AUTO;
            }
            if (this._comboCreateMode.selectedIndex == 1) 
            {
                return com.bqt.CreateMode.MANUAL;
            }
            return "";
        }

        public function get testType():String
        {
            if (this._comboTestType.selectedIndex == 0) 
            {
                return com.bqt.TestType.TEACHER;
            }
            if (this._comboTestType.selectedIndex == 1) 
            {
                return com.bqt.TestType.STUDENT;
            }
            return "";
        }

        function __setProp_browseLogo_TestDetailsScreen_Layer1_0():*
        {
            try 
            {
                this.browseLogo["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.browseLogo.emphasized = false;
            this.browseLogo.enabled = true;
            this.browseLogo.label = "Browse";
            this.browseLogo.labelPlacement = "left";
            this.browseLogo.selected = false;
            this.browseLogo.toggle = false;
            this.browseLogo.visible = true;
            try 
            {
                this.browseLogo["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_cbTestType_TestDetailsScreen_Layer1_0():*
        {
            var loc2:*=null;
            var loc3:*=null;
            var loc4:*=null;
            var loc5:*=0;
            var loc6:*=undefined;
            try 
            {
                this.cbTestType["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            var loc1:*=new fl.data.DataProvider();
            loc3 = [{"label":"Teacher`s Copy", "data":"teacher"}, {"label":"Student`s Copy", "data":"student"}];
            loc5 = 0;
            while (loc5 < loc3.length) 
            {
                loc2 = new fl.data.SimpleCollectionItem();
                loc4 = loc3[loc5];
                loc7 = 0;
                var loc8:*=loc4;
                for (loc6 in loc8) 
                {
                    loc2[loc6] = loc4[loc6];
                }
                loc1.addItem(loc2);
                ++loc5;
            }
            this.cbTestType.dataProvider = loc1;
            this.cbTestType.editable = false;
            this.cbTestType.enabled = true;
            this.cbTestType.prompt = "";
            this.cbTestType.restrict = "";
            this.cbTestType.rowCount = 5;
            this.cbTestType.visible = true;
            try 
            {
                this.cbTestType["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_cbTestMode_TestDetailsScreen_Layer1_0():*
        {
            var loc2:*=null;
            var loc3:*=null;
            var loc4:*=null;
            var loc5:*=0;
            var loc6:*=undefined;
            try 
            {
                this.cbTestMode["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            var loc1:*=new fl.data.DataProvider();
            loc3 = [{"label":"Auto Create", "data":"auto"}, {"label":"Select & Create", "data":"manual"}];
            loc5 = 0;
            while (loc5 < loc3.length) 
            {
                loc2 = new fl.data.SimpleCollectionItem();
                loc4 = loc3[loc5];
                loc7 = 0;
                var loc8:*=loc4;
                for (loc6 in loc8) 
                {
                    loc2[loc6] = loc4[loc6];
                }
                loc1.addItem(loc2);
                ++loc5;
            }
            this.cbTestMode.dataProvider = loc1;
            this.cbTestMode.editable = false;
            this.cbTestMode.enabled = true;
            this.cbTestMode.prompt = "";
            this.cbTestMode.restrict = "";
            this.cbTestMode.rowCount = 2;
            this.cbTestMode.visible = true;
            try 
            {
                this.cbTestMode["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_txtBoxTestName_TestDetailsScreen_Layer1_0():*
        {
            try 
            {
                this.txtBoxTestName["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.txtBoxTestName.displayAsPassword = false;
            this.txtBoxTestName.editable = true;
            this.txtBoxTestName.enabled = true;
            this.txtBoxTestName.maxChars = 20;
            this.txtBoxTestName.restrict = "";
            this.txtBoxTestName.text = "";
            this.txtBoxTestName.visible = true;
            try 
            {
                this.txtBoxTestName["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        function __setProp_txtTestDuration_TestDetailsScreen_Layer1_0():*
        {
            try 
            {
                this.txtTestDuration["componentInspectorSetting"] = true;
            }
            catch (e:Error)
            {
            };
            this.txtTestDuration.displayAsPassword = false;
            this.txtTestDuration.editable = true;
            this.txtTestDuration.enabled = true;
            this.txtTestDuration.maxChars = 3;
            this.txtTestDuration.restrict = "0123456789";
            this.txtTestDuration.text = "";
            this.txtTestDuration.visible = true;
            try 
            {
                this.txtTestDuration["componentInspectorSetting"] = false;
            }
            catch (e:Error)
            {
            };
            return;
        }

        public var logoContainer:flash.display.MovieClip;

        public var browseLogo:fl.controls.Button;

        public var cbTestType:fl.controls.ComboBox;

        public var btnNextfrmDetails:flash.display.SimpleButton;

        public var txtBoxTestName:fl.controls.TextInput;

        public var cbTestMode:fl.controls.ComboBox;

        public var txtTestDuration:fl.controls.TextInput;

        internal var _txtTestName:fl.controls.TextInput;

        internal var _comboCreateMode:fl.controls.ComboBox;

        internal var _comboTestType:fl.controls.ComboBox;

        internal var _txtTestDuration:fl.controls.TextInput;

        internal var _browseBtn:fl.controls.Button;

        internal var _logoContainer:flash.display.MovieClip;
    }
}
