package org.RTFlex 
{
    public class GroupElement extends Object
    {
        public function GroupElement(arg1:String, arg2:org.RTFlex.Format, arg3:int, arg4:int, arg5:int)
        {
            super();
            this.elements = new Array();
            this.name = arg1;
            this.format = arg2;
            this._colorPos = arg3;
            this._backgroundColorPos = arg4;
            this._fontPos = arg5;
            return;
        }

        public function addElement(arg1:*):void
        {
            this.elements.push(arg1);
            return;
        }

        public function getRTFCode():String
        {
            return this.format.formatText(this.getElementOutput(), this._colorPos, this._backgroundColorPos, this._fontPos, false);
        }

        internal function getElementOutput():String
        {
            var loc1:*="";
            var loc2:*=0;
            while (loc2 < this.elements.length) 
            {
                if (this.elements[loc2] is org.RTFlex.TextElement) 
                {
                    loc1 = loc1 + org.RTFlex.TextElement(this.elements[loc2]).getRTFCode();
                }
                else if (this.elements[loc2] is String) 
                {
                    loc1 = loc1 + this.elements[loc2];
                }
                ++loc2;
            }
            return loc1;
        }

        public var name:String;

        public var format:org.RTFlex.Format;

        internal var _colorPos:int;

        internal var _backgroundColorPos:int;

        internal var _fontPos:int;

        internal var elements:Array;
    }
}
