package org.RTFlex 
{
    import __AS3__.vec.*;
    import com.hurlant.util.*;
    import flash.display.*;
    import flash.net.*;
    import flash.utils.*;
    
    public class RTF extends Object
    {
        public function RTF()
        {
            super();
            this.elements = new Array();
            this.colorTable = new Array();
            this.fontTable = new Array();
            this._headerText = "";
            this._footerText = "";
            this._testDetails = "";
            return;
        }

        public function setFooterText(arg1:String):void
        {
            this._footerText = arg1;
            return;
        }

        public function getTestDetails():String
        {
            return this._testDetails;
        }

        public function setTestDetails(arg1:String):void
        {
            this._testDetails = arg1;
            return;
        }

        public function addBitmap(arg1:flash.display.BitmapData, arg2:Boolean=false):Boolean
        {
            var bmpData:flash.display.BitmapData;
            var underline:Boolean=false;
            var jpgEnc:org.RTFlex.JPGEncoder;
            var result:String;

            var loc1:*;
            jpgEnc = null;
            result = null;
            bmpData = arg1;
            underline = arg2;
            try 
            {
                jpgEnc = new org.RTFlex.JPGEncoder(100);
                result = com.hurlant.util.Hex.fromArray(jpgEnc.encode(bmpData));
                if (underline) 
                {
                    result = "\\ul{\\*\\shppict{\\pict{\\*\\picprop\\pngblip}" + result + " }}\\ulnone";
                }
                else 
                {
                    result = "{\\*\\shppict{\\pict{\\*\\picprop\\pngblip}" + result + " }}";
                }
                this.elements.push(result);
                return true;
            }
            catch (error:Error)
            {
                error.getStackTrace();
            }
            return false;
        }

        public function addLineBreak(arg1:String=null):void
        {
            if (arg1 && this.groupIndex(arg1) >= 0) 
            {
                org.RTFlex.GroupElement(this.elements[this.groupIndex(arg1)]).addElement("\\line");
            }
            else 
            {
                this.elements.push(" \\line ");
            }
            return;
        }

        public function encodeJPG(arg1:flash.display.BitmapData, arg2:int=50):flash.utils.ByteArray
        {
            var loc1:*=null;
            try 
            {
                loc1 = new org.RTFlex.JPGEncoder(arg2);
                return loc1.encode(arg1);
            }
            catch (error:Error)
            {
            };
            return null;
        }

        public function encodeJPGToBase64(arg1:flash.display.BitmapData, arg2:int=50):String
        {
            var loc1:*=null;
            try 
            {
                loc1 = new org.RTFlex.JPGEncoder(arg2);
                return com.hurlant.util.Hex.fromArray(loc1.encode(arg1));
            }
            catch (error:Error)
            {
            };
            return null;
        }

        internal function groupIndex(arg1:String):Number
        {
            var loc1:*=0;
            while (loc1 < this.elements.length) 
            {
                if (this.elements[loc1] is org.RTFlex.GroupElement && org.RTFlex.GroupElement(this.elements[loc1]).name == arg1) 
                {
                    return loc1;
                }
                ++loc1;
            }
            return -1;
        }

        internal function checkTables(arg1:org.RTFlex.Format):void
        {
            var loc1:*=this.fontTable.indexOf(arg1.font);
            var loc2:*=this.colorTable.indexOf(arg1.color);
            var loc3:*=this.colorTable.indexOf(arg1.backgroundColor);
            if (loc1 < 0 && arg1.font.length > 0) 
            {
                this.fontTable.push(arg1.font);
            }
            if (loc2 < 0 && !(arg1.color == null)) 
            {
                this.colorTable.push(arg1.color);
            }
            if (loc3 < 0 && !(arg1.backgroundColor == null)) 
            {
                this.colorTable.push(arg1.backgroundColor);
            }
            return;
        }

        internal function createColorTable():String
        {
            var loc2:*=null;
            var loc1:*="{\\colortbl;";
            var loc3:*=0;
            while (loc3 < this.colorTable.length) 
            {
                loc2 = this.colorTable[loc3] as org.RTFlex.RGB;
                loc1 = loc1 + ("\\red" + loc2.red + "\\green" + loc2.green + "\\blue" + loc2.blue + ";");
                ++loc3;
            }
            loc1 = loc1 + "}";
            return loc1;
        }

        internal function createFontTable():String
        {
            var loc2:*=0;
            var loc1:*="{\\fonttbl";
            if (this.fontTable.length != 0) 
            {
                loc2 = 0;
                while (loc2 < this.fontTable.length) 
                {
                    loc1 = loc1 + ("{\\f" + loc2 + " " + this.fontTable[loc2] + ";}");
                    ++loc2;
                }
            }
            else 
            {
                loc1 = loc1 + ("{\\f0 " + org.RTFlex.Fonts.ARIAL + "}");
            }
            loc1 = loc1 + "}";
            return loc1;
        }

        public function save(arg1:String, arg2:String="", arg3:String="inline", arg4:String="generated.rtf", arg5:String="_blank"):*
        {
            var loc1:*=null;
            var loc2:*=null;
            var loc3:*=null;
            if (arg1 == org.RTFlex.Method.LOCAL) 
            {
                (loc1 = new flash.utils.ByteArray()).writeMultiByte(this.createDocument(), "ansi");
                return loc1;
            }
            loc2 = new flash.net.URLRequestHeader("Content-type", "application/octet-stream");
            (loc3 = new flash.net.URLRequest(arg2 + "?name=" + arg4 + "&method=" + arg3)).requestHeaders.push(loc2);
            loc3.method = flash.net.URLRequestMethod.POST;
            loc3.data = this.save(org.RTFlex.Method.LOCAL);
            flash.net.navigateToURL(loc3, arg5);
            return null;
        }

        public static function addSymbol(arg1:org.RTFlex.Symbol):void
        {
            symbolCollection.push(arg1);
            return;
        }

        public static function getSymbolCollection():__AS3__.vec.Vector.<org.RTFlex.Symbol>
        {
            return symbolCollection.concat();
        }

        
        {
            symbolCollection = new Vector.<org.RTFlex.Symbol>();
        }

        public function writeUnsafeText(arg1:String, arg2:String=null):void
        {
            if (arg2 && this.groupIndex(arg2) >= 0) 
            {
                org.RTFlex.GroupElement(this.elements[this.groupIndex(arg2)]).addElement(arg1);
            }
            else 
            {
                this.elements.push(arg1);
            }
            return;
        }

        public function getFormatedText(arg1:String, arg2:org.RTFlex.Format=null):String
        {
            if (!arg2) 
            {
                arg2 = new org.RTFlex.Format();
            }
            this.checkTables(arg2);
            var loc1:*=this.fontTable.indexOf(arg2.font);
            var loc2:*=this.colorTable.indexOf(arg2.color);
            var loc3:*=this.colorTable.indexOf(arg2.backgroundColor);
            var loc4:*;
            return (loc4 = new org.RTFlex.TextElement(arg1, arg2, loc2, loc3, loc1)).getRTFCode();
        }

        public function writeText(arg1:String, arg2:org.RTFlex.Format=null, arg3:String=null):void
        {
            if (!arg2) 
            {
                arg2 = new org.RTFlex.Format();
            }
            this.checkTables(arg2);
            var loc1:*=this.fontTable.indexOf(arg2.font);
            var loc2:*=this.colorTable.indexOf(arg2.color);
            var loc3:*=this.colorTable.indexOf(arg2.backgroundColor);
            var loc4:*=new org.RTFlex.TextElement(arg1, arg2, loc2, loc3, loc1);
            if (arg3 && this.groupIndex(arg3) >= 0) 
            {
                org.RTFlex.GroupElement(this.elements[this.groupIndex(arg3)]).addElement(loc4);
            }
            else 
            {
                this.elements.push(loc4);
            }
            return;
        }

        public function addTableElement(arg1:org.RTFlex.TableElement):void
        {
            this.elements.push(arg1);
            return;
        }

        public function addTextGroup(arg1:String, arg2:org.RTFlex.Format):void
        {
            var loc1:*=0;
            var loc2:*=0;
            var loc3:*=0;
            var loc4:*=null;
            if (this.groupIndex(arg1) < 0) 
            {
                this.checkTables(arg2);
                loc1 = this.fontTable.indexOf(arg2.font);
                loc2 = this.colorTable.indexOf(arg2.color);
                loc3 = this.colorTable.indexOf(arg2.backgroundColor);
                loc4 = new org.RTFlex.GroupElement(arg1, arg2, loc2, loc3, loc1);
                this.elements.push(loc4);
            }
            return;
        }

        public function addPage(arg1:String=null):void
        {
            if (arg1 && this.groupIndex(arg1) >= 0) 
            {
                org.RTFlex.GroupElement(this.elements[this.groupIndex(arg1)]).addElement("\\page");
            }
            else 
            {
                this.elements.push(" \\page ");
            }
            return;
        }

        internal function createDocument():String
        {
            var loc1:*="{\\rtf1\\ansi\\deff0";
            if (this.orientation == org.RTFlex.Orientation.LANDSCAPE) 
            {
                loc1 = loc1 + "\\landscape";
            }
            if (this.marginLeft > 0) 
            {
                loc1 = loc1 + ("\\margl" + this.marginLeft.toString());
            }
            if (this.marginRight > 0) 
            {
                loc1 = loc1 + ("\\margr" + this.marginRight.toString());
            }
            if (this.marginTop > 0) 
            {
                loc1 = loc1 + ("\\margt" + this.marginTop.toString());
            }
            if (this.marginBottom > 0) 
            {
                loc1 = loc1 + ("\\margb" + this.marginBottom.toString());
            }
            loc1 = loc1 + ("\\deflang" + this.language);
            loc1 = loc1 + this.createColorTable();
            loc1 = loc1 + this.createFontTable();
            loc1 = loc1 + this.getHeaderText();
            loc1 = loc1 + this.getFooterText();
            loc1 = loc1 + this.getTestDetails();
            if (this.pageNumbering) 
            {
                loc1 = loc1 + "{\\header\\pard\\qr\\plain\\f0\\chpgn\\par}";
            }
            if (this.columns > 0) 
            {
                loc1 = loc1 + ("\\cols" + this.columns.toString());
            }
            if (this.columnLines) 
            {
                loc1 = loc1 + "\\linebetcol";
            }
            var loc2:*=0;
            while (loc2 < this.elements.length) 
            {
                if (this.elements[loc2] is org.RTFlex.GroupElement) 
                {
                    loc1 = loc1 + org.RTFlex.GroupElement(this.elements[loc2]).getRTFCode();
                }
                else if (this.elements[loc2] is org.RTFlex.TextElement) 
                {
                    loc1 = loc1 + org.RTFlex.TextElement(this.elements[loc2]).getRTFCode();
                }
                else if (this.elements[loc2] is org.RTFlex.TableElement) 
                {
                    loc1 = loc1 + org.RTFlex.TableElement(this.elements[loc2]).getRTFCode();
                }
                else if (this.elements[loc2] is String) 
                {
                    loc1 = loc1 + this.elements[loc2];
                }
                ++loc2;
            }
            loc1 = loc1 + "}";
            return loc1;
        }

        public function addTab(arg1:String=null):void
        {
            if (arg1 && this.groupIndex(arg1) >= 0) 
            {
                org.RTFlex.GroupElement(this.elements[this.groupIndex(arg1)]).addElement("\\tab");
            }
            else 
            {
                this.elements.push(" \\tab ");
            }
            return;
        }

        public function getRTFBytes(arg1:String="ansi"):flash.utils.ByteArray
        {
            var loc1:*=new flash.utils.ByteArray();
            loc1.writeMultiByte(this.createDocument(), arg1);
            return loc1;
        }

        public function getHeaderText():String
        {
            return this._headerText;
        }

        public function setHeaderText(arg1:String):void
        {
            this._headerText = arg1;
            return;
        }

        public function getFooterText():String
        {
            return this._footerText;
        }

        public var pageNumbering:Boolean;

        public var marginLeft:int=1800;

        public var marginRight:int=1800;

        public var marginBottom:int=1440;

        public var language:String="1033";

        public var columns:int=0;

        public var columnLines:Boolean=false;

        public var orientation:Boolean=false;

        internal var elements:Array;

        internal var colorTable:Array;

        internal var fontTable:Array;

        internal var _footerText:String;

        internal var _headerText:String;

        internal var _testDetails:String;

        internal static var symbolCollection:__AS3__.vec.Vector.<org.RTFlex.Symbol>;

        public var marginTop:int=1440;
    }
}
